CREATE DOMAIN LONGLONG as INT;
CREATE DOMAIN LONG as INT;
CREATE DOMAIN DATETIME AS TIMESTAMP;
CREATE DOMAIN OBJECT AS BLOB;
CREATE DOMAIN MONEY AS NUMERIC(19,2);

CREATE TABLE "_SYS_RELATIONSHIP"(
   "_ROWID"       INT,
   "SOURCE_TABLE" CHARACTER VARYING(64),
   "SOURCE_COLUMN" CHARACTER VARYING(64),
   "RELATIONSHIPNAME" CHARACTER VARYING(64),
   "OPERATOR" CHARACTER VARYING(2),
   "ONE_TO_MANY" CHARACTER VARYING(2),
   "DEST_TABLE" CHARACTER VARYING(64),
   "DEST_COLUMN" CHARACTER VARYING(64),
   "CASCADE_DELETE" INTEGER,
   "BLOCK_DELETE" INTEGER);

CREATE TABLE "_SYS_APPS"(
   "_ROWID"  INT,
   "APPNAME" CHARACTER VARYING(64)
);

CREATE TABLE "_SYS_PERM"(
   "_ROWID"   INT,
   "NAME"     CHARACTER VARYING(64),
   "P_DELETE" CHAR(1),
   "P_INSERT" CHAR(1),
   "P_SELECT" CHAR(1),
   "P_UPDATE" CHAR(1),
   "TABLE"    CHARACTER VARYING(64)
);

CREATE TABLE "_SYS_REPLICATION"(
   "_ROWID"          INT,
   "CONFLICT_CODE"   CHARACTER VARYING(64),
   "LOCAL_DATE"      TIMESTAMP,
   "REMOTE_DATE"     TIMESTAMP,
   "TABLENAME"       CHARACTER VARYING(64),
   "TARGET_DATABASE" CHARACTER VARYING(64),
   "TARGET_HOST"     CHARACTER VARYING(64),
   "TARGET_PASSWORD" CHARACTER VARYING(64)
);

CREATE TABLE "_SYS_USERS"(
   "_ROWID"         INT,
   "APPSECURITY"    INT,
   "AUTHORIZEDAPPS" CHARACTER VARYING(1023),
   "EMAIL"          CHARACTER VARYING(1023),
   "FULLNAME"       CHARACTER VARYING(64),
   "LOGIN"          CHARACTER VARYING(20),
   "PASSWORD"       CHARACTER VARYING(20),
   "POPSERVER"      CHARACTER VARYING(1023),
   "SMTPSERVER"     CHARACTER VARYING(1023),
   "USERGROUP"      CHARACTER VARYING(20)
);

COMMIT;
