#ifndef FBCDigestPassword__H
#define FBCDigestPassword__H

/*!
@function fbcDigestPassword
 @discussion Generates and returns a 16 byte string consisting of hexadecimal characters.  The string is a digested version of the user name and the clear text password.  The digested password is created via a lossy algorithm, i.e. it cannot be decrypted.  It is up to the caller to provide a result buffer that is min. 17 bytes long.
 */
char* fbcDigestPassword(const char* userName, const char* password, char* result);

#endif /* FBCDigestPassword__H */
