#ifndef FBCPList__H
#define FBCPList__H

FBCPList* fbcplDictionary(void);
FBCPList* fbcplArray(void);

FBCPList* fbcplParse(const char* plist);

FBCPList* fbcplAddToDictionary(FBCPList* plist, const char* name, const FBCPList* value);
FBCPList* fbcplSetValueForKey (FBCPList* plist, const char* name, const FBCPList* value);
FBCPList* fbcplEmptyArray     (void);
FBCPList* fbcplAddToArray     (FBCPList* plist, const FBCPList* value);
FBCPList* fbcplMakeString     (const char* str);

Bool fbcplIsDictionary(const FBCPList* pl);
Bool fbcplIsArray     (const FBCPList* pl);
Bool fbcplIsString    (const FBCPList* pl);

unsigned fbcplCount(const FBCPList* pl);

const char*     fbcplKeyAtIndex  (const FBCPList* pl, unsigned indx);
const FBCPList* fbcplValueForKey (const FBCPList* pl, const char* key);
const FBCPList* fbcplValueAtIndex(const FBCPList* pl, unsigned indx);
const char*     fbcplString      (const FBCPList* pl);

FBCPList* fbcplCopy(const FBCPList* pl);

void fbcplRelease(FBCPList* pl);

char* fbcplUnparse(const FBCPList* pl);
void  fbcplDump   (const FBCPList* pl);

#endif /* FBCPList__H */
