/*
 *  FBCRow.h
 *  Server
 *
 *  Created by Svend  Bodilsen on Sun Jan 23 2005.
 *  Copyright (c) 2005 __MyCompanyName__. All rights reserved.
 *
 */
#ifndef FBCRow__H
#define FBCRow__H

#include <FBCAccess/FBDataTypeDefs.h>

typedef union FBCColumn FBCColumn;

//typedef struct FBCBitValue
//{
//   unsigned size;        // Size of the bit string measured in bytes
//   unsigned char* bytes; // Pointer to an array of bytes
//} FBCBitValue;


//typedef struct FBCUnformattedTime 
//{
//   double        seconds;   // Timestamp: Since 2001-01-01 00:00:00 // Time: Since 00:00:00
//   unsigned char tzSign;    // Sign of timezone displacement
//   unsigned int  tzValue;   // Unsigned timezone displacement
//} FBCUnformattedTime;


//typedef struct FBCBlobDirect 
//{
//   unsigned char kind;        // 0 => indirect, 1 => direct
//   unsigned int  blobSize;    // Size of BLOB/CLOB in bytes
//   void*         blobData;
//} FBCBlobDirect;


//typedef struct FBCBlobIndirect
//{
//   unsigned char kind;                // 0 => direct, 1 => indirect
//   char          handleAsString[28];  // @'<24 hex digits>'\0
//} FBCBlobIndirect;

typedef struct FBCLob
{
   unsigned char kind;                // 0 => direct, 1 => indirect
   char          handleAsString[28];  // @'<24 hex digits>'\0
} FBCLob;

typedef struct FBCUnformattedCircaDate 
{
   double lower;
   double upper;
} FBCUnformattedCircaDate;

typedef struct FBCAnyType 
{
   int type;
   FBCColumn* column;
} FBCAnyType;

union FBCColumn
{
   char                    tinyInteger;
   short                   shortInteger;
   int                     integer;
   int                     primaryKey;
#ifdef WIN32
   _int64                  longInteger;
#else
   long long               longInteger;
#endif
   unsigned char           boolean;
   char                    character[0x7fffffff];
//   double                  float;   
   double                  numeric;
   double                  real;
   double                  decimal;
   FBCBitValue             bit;
   char                    date[11];           // YYYY-MM-DD
   int                     unformattedDate;
   char                    time[9];            // HH:MM:SS
   char                    timeTZ[34];         // YYYY-MM-DD HH:MM:SS.sssss+HH:MM
   char                    timestampTZ[34];
   char                    timestamp[28];
   char                    yearMonth[64];          
   char                    dayTime[32];                   //  days:hh:ss.ffffff
   FBCLob                  blob;
   FBCLob                  clob;
   char                    circaDate[64];
   double                  rawDate;
   FBCAnyType              anyType;    
   FBCUnformattedTime      rawTime;
   FBCUnformattedTime      rawTimeTZ;
   FBCUnformattedTime      rawTimestamp;
   FBCUnformattedTime      rawTimestampTZ;
   int                     rawYearMonth;
   double                  rawDayTime;
   FBCUnformattedCircaDate rawCircaDate;
};

typedef FBCColumn* FBCRow;

#endif
