/*
 *  FBCTimeZones.h
 *  Client
 *
 *  Created by sb on Tue Jan 22 2002.
 *  Copyright (c) 2001 Front. All rights reserved.
 *
 */
#ifndef FBCTimeZone__H
#define FBCTimeZone__H

typedef struct FBCTimeZone FBCTimeZone;

FBCTimeZone* fbctzTimeZone ( const FBCDatabaseConnection* connection, const char* name );

char* fbctzName         ( FBCTimeZone* self );
char* fbctzAbbreviation ( FBCTimeZone* self );
char* fbctzAlternate    ( FBCTimeZone* self );

// Split the time into components according to the tz
void fbctzLocalTime
 (
   FBCTimeZone*    tz,      
   double          time,      // epoch 2001-01-01 00:00:00
   unsigned int*   year,      // 1917-2038
   unsigned int*   month,     // 1-12
   unsigned int*   day,       // 1-31
   unsigned int*   hour,      // 0-23
   unsigned int*   minute,    // 0-59
   double*         second,    // 0-59
            int*   zone,
            int*   dst,
            char** name       
 );

// Build a UTC from a local time in the time zone
double fbctzUTC
 (
   FBCTimeZone*  tz,       
   unsigned int  year,
   unsigned int  month,
   unsigned int  day,
   unsigned int  hour,
   unsigned int  minute,
   unsigned int  second
 );

// Return the time zone for the UTC time in the zone
int fbctzZoneOfTimestamp
 (
    FBCTimeZone*  self,
    unsigned int  year,
    unsigned int  month,
    unsigned int  day,
    unsigned int  hour,
    unsigned int  minute,
    unsigned int  second
 );

int fbctzGMTOffset ( FBCTimeZone* self );

int fbctzZoneOf    ( FBCTimeZone* tz, double time );

// The time zone offset of now
int fbctzZoneOfNow ( FBCTimeZone* tz );

// Returns the GMT offset of the given time in the specified time zone
int fbctzTz
 ( FBCTimeZone*  self,
   unsigned int  year,
   unsigned int  month,
   unsigned int  day,
   unsigned int  hour,
   unsigned int  minute,
   unsigned int  second
 );

// Returns the local time zone expressed symbolically
char* fbctzLocalTimeZoneName ( char* buffer, unsigned int length );

#endif
