/* FBDataTypeDefs.h created by sb on Wed 18-Oct-2000 */

#ifndef FBDataTypeDefs__H
#define FBDataTypeDefs__H

#define FB_Undecided	-1
#define	FB_PrimaryKey	0
#define	FB_Boolean	1
#define	FB_Integer	2
#define	FB_SmallInteger	3
#define	FB_Float	4
#define	FB_Real		5
#define	FB_Double	6
#define	FB_Numeric	7
#define FB_Decimal	8
#define FB_Character	9
#define FB_VCharacter	10
#define	FB_Bit		11
#define FB_VBit		12
#define FB_Date		13
#define FB_Time		14
#define FB_TimeTZ	15
#define FB_Timestamp	16
#define FB_TimestampTZ	17
#define FB_YearMonth	18
#define FB_DayTime	19
#define FB_CLOB		20
#define FB_BLOB		21
#define FB_TinyInteger	22
#define FB_LongInteger	23
#define FB_CircaDate	24
#define FB_AnyType	25

#define FBNoKey		0x7FFFFFFF   // MAXINT
typedef int 		FBPrimaryKey;
typedef unsigned char	FBBoolean;
typedef unsigned char   FBChar;
typedef unsigned short  FBUShort;
#define FBTinyIntegerBinaryPositions	7
#define FBSmallIntegerBinaryPositions   15
#define FBSmallIntegerDecimalPositions  5
#define FBIntegerBinaryPositions   	31
#define FBIntegerDecimalPositions   	10

typedef char	FBTinyInteger;
typedef int		FBInteger;
typedef short  FBSmallInteger;

// A 64-bit integer (designated differently in different compilers)
#ifdef WIN32                            // Microsoft Visual C++
   typedef _int64       FBLongInteger;
   #define LLD          "I64d"          // [s]printf format specification
#else
   typedef long long    FBLongInteger;
   #define LLD          "lld"           // [s]printf format specification
#endif

typedef unsigned int FBTVersion;
#define FBTNoVersion ((FBTVersion)-1)

#define FBNumericMaxLength		4
#define FBNumericBinaryPositions	64
#define FBNumericDecimalPositions	19
#define FBNumericMaxExponent		127
#define FBNumericMinExponent		-127

typedef struct FBNumeric
{   signed   int exponent:8;
    unsigned int length:4;
    unsigned int isNegative:1;
    unsigned int isOptimal:1;
    unsigned int tzExplicit:1;
    unsigned int tzSign:1;
    unsigned int tzValue:16;
    unsigned short mantissa[FBNumericMaxLength];
} FBNumeric;

#define FBDecimalMaxLength		8
#define FBDecimalBinaryPositions	128
#define FBDecimalDecimalPositions	38
#define FBDecimalMaxExponent		127
#define FBDecimalMinExponent		-127

typedef struct FBDecimal {
    signed   int exponent:8;
    unsigned int length:4;     // length == 0 && isNegative == True -> NaN
    unsigned int isNegative:1;
    unsigned int isOptimal:1;
    unsigned int tzExplicit:1;
    unsigned int tzSign:1;
    unsigned int tzValue:16;
    unsigned short mantissa[FBDecimalMaxLength];
} FBDecimal;

#define FBFloatPrecision		FBNumericDecimalPositions
#define FBRealPrecision			FBNumericDecimalPositions
#define FBDoublePrecision		FBDecimalDecimalPositions

typedef FBNumeric		FBFloat;
typedef FBNumeric		FBReal;
typedef FBDecimal		FBDouble;

#define FBCharacterMaxLength	2147483646
#define FBBitMaxLength		2147483646
#define FBBLOBMaxLength		2147483646
#define FBCLOBThreshold		512
#define FBBLOBThreshold		512

#define FBBlobHandleByteSize	24	// sizeof(FBTBlobHandle)*2

#define FBTimeMaxPrecision	6	// 10.1 Syntax rules 4

typedef FBNumeric FBDate;
typedef FBNumeric FBTime;
typedef FBNumeric FBTimeTZ;
typedef FBNumeric FBTimestamp;
typedef FBNumeric FBTimestampTZ;
typedef FBInteger FBYearMonth;
typedef FBNumeric FBDayTime;

#define FBPrimaryKey_size	sizeof(FBPrimaryKey)
#define FBBoolean_size		sizeof(FBBoolean)
#define FBInteger_size		sizeof(FBInteger)
#define FBSmallInteger_size	sizeof(FBSmallInteger)
#define FBTinyInteger_size	sizeof(FBTinyInteger)
#define FBLongInteger_size	sizeof(FBLongInteger)
#define FBFloat_size		sizeof(FBFloat)
#define FBReal_size		sizeof(FBReal)
#define FBDouble_size		sizeof(FBDouble)
#define FBNumeric_size		sizeof(FBNumeric)
#define FBDecimal_size		sizeof(FBDecimal)
#define FBDate_size		sizeof(FBDate)
#define FBTime_size		sizeof(FBTime)
#define FBTimeTZ_size		sizeof(FBTimeTZ)
#define FBTimestamp_size	sizeof(FBTimestamp)
#define FBTimestampTZ_size	sizeof(FBTimestampTZ)
#define FBYearMonth_size	sizeof(FBYearMonth)
#define FBDayTime_size		sizeof(FBDayTime)

#endif /* FBDataTypeDefs__H */
