
create database movies;

connect to movies user _system;
create user movies;
create schema authorization movies;
alter user movies set default schema movies;
commit;
disconnect current;

connect to movies user movies;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE, READ WRITE;
CREATE TABLE "Director"
 ( "Movie_Id"  INTEGER,
   "Talent_Id" INTEGER
 );
CREATE TABLE "Movie"
 ( "Category"      CHAR(20),
   "Date_Released" TIMESTAMP(0),
   "Movie_Id"      INTEGER,
   "Poster_Name"   CHAR(255),
   "Rated"         CHAR(10),
   "Revenue"       INTEGER,
   "Studio_Id"     INTEGER,
   "Title"         CHAR(255) NOT NULL,
   "Trailer_Name"  CHAR(255)
 );
CREATE TABLE "Movie_Role"
 ( "Movie_Id"  INTEGER,
   "Role_Name" CHAR(30),
   "Talent_Id" INTEGER
 );
CREATE TABLE "Plot_Summary"
 ( "Movie_Id" INTEGER,
   "Summary"  CLOB
 );
CREATE TABLE "Review"
 ( "Movie_Id"  INTEGER NOT NULL,
   "Review"    CLOB,
   "Review_Id" INTEGER,
   "Reviewer"  CHAR(50)
 );
CREATE TABLE "Studio"
 ( "Budget"    INTEGER NOT NULL,
   "Name"      CHAR(40) NOT NULL,
   "Studio_Id" INTEGER
 );
CREATE TABLE "Talent"
 ( "First_Name" CHAR(20) NOT NULL,
   "Last_Name"  CHAR(30) NOT NULL,
   "Talent_Id"  INTEGER
 );
CREATE TABLE "Talent_Photo"
 ( "Photo"     BLOB,
   "Talent_Id" INTEGER
 );
CREATE TABLE "Voting"
 ( "Movie_Id"        INTEGER,
   "Number_Of_Votes" INTEGER,
   "Running_Average" FLOAT(9)
 );
COMMIT;
DISCONNECT CURRENT;
connect to movies user movies;
SET TRANSACTION ISOLATION LEVEL SERIALIZABLE, READ WRITE;
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (7, 'Paramount Pictures', 5000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (8, 'MGM', 17000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (11, 'Columbia Pictures', 22000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (13, 'Filmsonor', 200000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (9, 'Warner Brothers', 100000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (50, 'ZZ Studios', 19778543);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (12, '20th Century Fox', 100000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (14, 'Hemdale Film Corporation', 11000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (15, 'Kartemquin Films', 70000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (16, 'Universal Pictures', 23000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (19, 'Propaganda Films', 1000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (32, 'New Line Cinema', 3000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (51, 'Cargo Films', 1000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (20, 'Zoetrope Studios', 21000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (18, 'ITC Films', 11000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (21, 'Gaumont International', 22000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (22, 'Greenwich Film Production', 3000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (23, 'Walt Disney Productions', 4000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (24, 'New World Entertainment', 52000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (25, 'Miramax Films', 56000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (26, 'Pacific Western', 7000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (27, 'Rank Film Productions', 8000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (28, 'CiBy 2000', 9000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (29, 'The Andre Company', 10000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (30, 'Working Title Films', 11000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (31, 'Alexandre Films', 26000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (33, 'De Laurentis', 4000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (34, 'F.C. Produzioni', 55000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (35, 'Carolco Pictures', 6000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (36, 'Samuel Goldwyn Company', 7000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (37, '40 Acres and a Mule Filmworks', 81000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (38, 'Avenue Pictures', 9000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (39, 'Cineplex Odeon', 10000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (40, 'RKO Radio Pictures', 1000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (41, 'British Lion Film Corp.', 2000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (42, 'Civilhand Zenith', 3000000);
INSERT INTO "Studio" ("Studio_Id", "Name", "Budget") VALUES (43, 'AFI', 4000000);
COMMIT;
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (4.789738, 24, 102);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (5.306278, 27, 113);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (5.212362, 27, 111);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (5.353237, 27, 114);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (5.400195, 28, 115);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (5.588028, 28, 119);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (5.634986, 29, 120);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (5.681944, 29, 121);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (5.822819, 30, 124);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (5.869777, 30, 125);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (5.916735, 30, 126);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (5.963693, 30, 127);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.010652, 31, 128);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.104568, 31, 130);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.151526, 31, 131);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.198484, 31, 132);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.245443, 32, 133);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.339359, 32, 135);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.386317, 32, 136);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.433276, 33, 137);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.480234, 33, 138);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.57415, 33, 140);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.621108, 34, 141);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.761983, 34, 144);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.808941, 35, 145);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.902858, 35, 147);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.949816, 35, 148);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.996774, 35, 149);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (7.043732, 36, 150);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (7.090691, 36, 151);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (7.137649, 36, 152);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (7.184607, 36, 153);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (7.231565, 37, 154);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (7.278523, 37, 155);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (7.419398, 38, 158);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (7.466356, 38, 159);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (7.513314, 38, 160);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (7.607231, 39, 162);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (7.701147, 39, 164);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (7.748106, 39, 165);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (7.795064, 39, 166);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (7.935938, 40, 169);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (7.982897, 40, 170);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.029855, 41, 171);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.076813, 41, 172);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.170730000000001, 41, 174);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.264646000000001, 42, 176);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.311604000000001, 42, 177);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.358561999999999, 42, 178);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.405521, 43, 179);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.452479, 43, 180);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.593353, 43, 183);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.640312, 44, 184);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.68727, 44, 185);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.734228, 44, 186);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.781186, 44, 187);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.875102999999999, 45, 189);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.922060999999999, 45, 190);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.969018999999999, 45, 191);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (9.062936000000001, 46, 193);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (9.109894000000001, 46, 194);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (9.203810000000001, 47, 196);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (9.250768000000001, 47, 197);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (9.297727, 47, 198);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (9.391643, 47, 200);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (9.48556, 48, 202);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (9.532518, 48, 203);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (4.74278, 24, 101);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.855899, 35, 146);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (5.541069, 28, 118);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (4.836696, 25, 103);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.546395, 43, 182);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (9.015976999999999, 46, 192);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (9.344685, 47, 199);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (7.37244, 37, 157);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.715025, 34, 143);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.828144999999999, 45, 188);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.499437, 43, 181);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (8.217688000000001, 42, 175);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (9.626434, 49, 205);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.05761, 31, 129);
INSERT INTO "Voting" ("Running_Average", "Number_Of_Votes", "Movie_Id") VALUES (6.668067, 34, 142);
COMMIT;
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (87, 'Han Solo', 101);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (87, 'Indiana Jones', 102);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (92, 'Michel''s Wife', 103);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (90, 'Michel', 103);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (93, 'The Godfather', 103);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (86, 'Luke Skywalker', 101);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (103, 'Ugarte', 111);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (100, 'Rick Blaine', 111);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (101, 'Ilsa Lund', 111);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (103, 'Franz Becker', 113);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (112, 'Charlotte Haze', 114);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (110, 'Humbert Humbert', 114);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (102, 'Senor Ferrari', 111);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (113, 'Rex', 114);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (111, 'Lolita Haze', 114);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (115, 'John Russell', 115);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (117, 'Bob McKenzie', 118);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (119, 'Brewmeister Smith', 118);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (118, 'Doug McKenzie', 118);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (120, 'Princess Leia', 101);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (121, 'Marion Ravenwood', 102);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (125, 'Christina Delasalle', 119);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (124, 'Nicole Horner', 119);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (126, 'Mr Raymond', 119);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (122, 'Inspecteur Ficher', 119);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (123, 'Michel Delasalle', 119);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (139, 'Mme Musquin', 120);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (137, 'Thrse', 120);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (140, 'Pierre Mortez', 120);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (145, 'Pharmacien', 120);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (141, 'Katia', 120);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (146, 'Mr Lebl', 120);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (143, 'Felix', 120);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (147, 'Mme Lebl', 120);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (142, 'Preskovitch', 120);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (144, 'Zezette', 120);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (149, 'Mme Tapioca', 121);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (158, 'Louison', 121);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (148, 'Mlle Plusse', 121);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (157, 'Clapet', 121);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (154, 'Aurore Interligator', 121);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (152, 'Robert Kube', 121);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (150, 'Marcel Tapioca', 121);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (153, 'Georges Interligator', 121);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (155, 'Julie Clapet', 121);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (163, 'Shooter', 125);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (161, 'Coach Norman Dale', 125);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (162, 'Myra Fleener', 125);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (206, 'William Gates', 126);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (208, 'Isiah Thomas', 126);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (205, 'Arthur Agee', 126);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (198, 'Ned', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (179, 'Phillip Winter', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (195, 'Raymond Monnet', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (197, 'Mario', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (183, 'Hotel guest', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (173, 'Woman in street car', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (187, 'Irina Farber', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (201, 'Doctor', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (188, 'Peter', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (184, 'David', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (168, 'Bernie', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (170, 'Policeman', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (175, 'Narcotics agent', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (193, 'Truck driver', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (203, 'Anton Farber', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (200, 'Edith Farber', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (185, 'Karl', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (174, 'Elsa Farber', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (194, 'Astronaut', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (180, 'Burt', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (186, 'Nora Oliveira', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (171, 'Maid', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (166, 'Hotel guest', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (119, 'Henry Farber', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (182, 'Claire Tourneur', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (176, 'Lydia', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (204, 'Buzzer', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (196, 'Krasikova', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (177, 'Makiko', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (167, 'Eugene Fitzpatrick', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (178, 'Old man Alfred', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (169, 'Heidi', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (202, 'Custodian', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (190, 'Receptionist', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (172, 'Ronda', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (152, 'Maisie', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (199, 'Mrs Mori', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (181, 'Mechanic', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (192, 'Chico Remy', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (189, 'Sam Farber', 124);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (213, 'Catherine', 127);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (209, 'Solange', 127);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (212, 'Antoine', 127);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (211, 'Jean', 127);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (214, 'Sondra Walker', 128);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (215, 'Michelle', 128);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (87, 'Richard Walker', 128);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (221, 'Annie', 129);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (220, 'Betty', 129);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (223, 'Eddy', 129);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (217, 'Zorg', 129);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (219, 'Bob', 129);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (222, 'Lisa', 129);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (225, 'Hannibal Lecter (1)', 130);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (224, 'Hannibal Lecter (2)', 130);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (227, 'Will Graham', 130);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (226, 'Jack Crawford', 130);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (230, 'Jack Walsh', 131);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (231, 'Marvin Dorfler', 131);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (226, 'Jimmy Serrano', 131);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (234, 'Jonathan Mardukas', 131);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (229, 'Eddie Moscone', 131);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (233, 'Alonzo Mosely', 131);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (236, 'Clay Gregory', 132);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (238, 'Mike Swale', 132);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (235, 'Bridget Gregory', 132);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (240, 'Michael', 133);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (163, 'Lyle', 133);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (239, 'Wayne', 133);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (241, 'Suzanne', 133);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (87, 'Colonel', 135);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (246, 'Lieutenant Colonel Kilgore', 135);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (247, 'Captain Benjamin L. Willard', 135);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (245, 'Clean', 135);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (93, 'Colonel Walter Kurtz', 135);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (252, 'Johanna', 136);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (250, 'Enzo Molinari', 136);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (248, 'Alfredo', 136);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (249, 'Jacques Mayol', 136);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (250, 'Drummer', 137);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (257, 'Fred', 137);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (258, 'Big Negro', 137);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (259, 'Robin', 137);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (256, 'Helena', 137);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (254, 'Florist', 137);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (255, 'Commisaire Gesberg', 137);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (217, 'The Roller', 137);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (253, 'Batman', 137);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (260, 'Cynthia Hawkins', 138);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (272, 'Barbara', 140);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (274, 'Boogie', 140);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (275, 'Fenwick', 140);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (276, 'Modell', 140);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (271, 'Beth', 140);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (273, 'Bagel', 140);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (278, 'Billy', 140);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (280, 'Shrevie', 140);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (279, 'Eddie', 140);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (217, 'Nikita''s boyfriend', 141);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (282, 'Zap', 141);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (200, 'Old teacher', 141);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (283, 'Nikita', 141);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (250, 'Le Nettoyeur', 141);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (248, 'Coyotte', 141);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (284, 'Bob', 141);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (281, 'Rico', 141);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (230, 'James Conway', 142);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (286, 'Joe Buddha', 142);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (288, 'Tommy DeVito', 142);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (290, 'Karen Hill', 142);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (289, 'Paul Cicero', 142);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (287, 'Henry Hill', 142);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (298, 'Elwood', 143);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (293, 'Soloist', 143);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (120, 'Mystery Woman', 143);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (292, 'Reverend Cleophus James', 143);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (299, 'Ray', 143);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (295, 'Burton Mercer', 143);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (302, 'Chic Lady', 143);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (435, 'Cook County Clerk', 143);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (296, 'Waiter', 143);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (291, 'Soul Food Cafe Owner', 143);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (301, 'Curtis', 143);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (297, 'Joliet Jake', 143);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (306, 'Miles Russell', 144);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (304, 'Bug', 144);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (303, 'Maisy Russell', 144);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (305, 'Tia Russell', 144);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (307, 'Chanice Kobolowski', 144);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (295, 'Buck Russell', 144);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (313, 'Yul Brenner', 145);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (312, 'Junior Bevel', 145);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (295, 'Irv', 145);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (309, 'Leon', 145);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (311, 'Sanka Coffie', 145);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (316, 'Rachael', 146);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (314, 'Batty', 146);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (318, 'Gaff', 146);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (317, 'Pris', 146);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (319, 'Bryant', 146);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (87, 'Deckard', 146);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (325, 'Heather Chandler', 147);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (323, 'J.D.', 147);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (321, 'Heather Duke', 147);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (322, 'Heather McNamara', 147);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (324, 'Veronica', 147);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (326, 'Pat Boone', 148);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (329, 'Roger Smith', 148);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (327, 'Michael Moore', 148);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (328, 'Bob Eubanks', 148);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (338, 'Larry', 149);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (337, 'Chief Karlin', 149);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (336, 'Alan Stanwick', 149);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (330, 'Fletch', 149);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (331, 'Fat Sam', 149);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (334, 'Gail Stanwick', 149);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (335, 'Chick Hearn', 149);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (333, 'Kareem Abdul-Jabbar', 149);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (342, 'Noah Cross', 150);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (339, 'Evelyn Mulwray', 150);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (216, 'Man with Knife', 150);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (341, 'Jake Gittes', 150);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (340, 'Escobar', 150);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (230, 'Al Capone', 151);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (347, 'George Stone', 151);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (346, 'Oscar Wallace', 151);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (344, 'Elliot Ness', 151);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (345, 'Jim Malone', 151);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (348, 'Jess', 152);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (120, 'Marie', 152);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (351, 'Harry Burns', 152);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (350, 'Sally Albright', 152);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (354, 'Father Ellerton', 153);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (359, 'Father Greg', 153);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (361, 'Mrs. Unsworth', 153);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (355, 'Lisa Unsworth', 153);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (357, 'Maria Kerrigan', 153);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (358, 'Housekeeper', 153);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (352, 'Mr. Unsworth', 153);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (356, 'Father Matthew', 153);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (353, 'Graham', 153);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (324, 'Jo March', 154);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (364, 'Marmee March', 154);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (362, 'Laurie', 154);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (365, 'Mrs. Victor', 155);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (366, 'Basie', 155);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (362, 'Jim', 155);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (396, 'Buzz Lightyear', 158);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (395, 'Woody', 158);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (393, 'The Ancient Booer', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (390, 'The Assistant Brute', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (379, 'The Princess Bride', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (392, 'Valerie', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (384, 'The Impressive Clergyman', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (389, 'The Queen', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (388, 'The King', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (381, 'The Grandfather', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (385, 'Vizzini', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (394, 'The Mother', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (380, 'Fezzik', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (387, 'The Albino', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (383, 'Prince Humperdinck', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (386, 'Inigo Montoya', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (391, 'Yellin', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (351, 'Miracle Max', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (378, 'The Grandson', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (382, 'Count Rugen', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (377, 'Westley', 157);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (403, 'Brett', 159);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (401, 'Kane', 159);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (398, 'Dallas', 159);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (233, 'Parker', 159);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (402, 'Lambert', 159);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (400, 'Ash', 159);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (399, 'Ripley', 159);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (404, 'Sarah Connor', 160);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (406, 'Kyle Reese', 160);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (405, 'Terminator', 160);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (422, 'Julie', 162);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (417, 'Michael', 162);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (418, 'Roommate', 162);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (420, 'Sandy', 162);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (419, 'Ron', 162);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (425, 'Pumpkin', 164);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (428, 'Winston Wolf', 164);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (430, 'Mia', 164);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (427, 'Butch', 164);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (286, 'Jules', 164);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (431, 'Vincent Vega', 164);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (429, 'Honey Bunny', 164);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (434, 'Fiona', 165);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (433, 'Ada', 165);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (167, 'Stewart', 165);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (428, 'Baines', 165);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (437, 'John Hammond', 166);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (438, 'Ian Malcolm', 166);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (436, 'Dr. Ellie Sattler', 166);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (167, 'Doctor Alan Grant', 166);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (447, 'Oskar Schindler', 169);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (449, 'Itzhak Stern', 169);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (448, 'Amon Goeth', 169);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (450, 'Helen Hirsch', 169);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (453, 'Kent Dorfman', 170);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (297, 'Bluto', 170);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (452, 'Jennings', 170);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (121, 'Katy', 170);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (451, 'Larry Kroger', 170);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (385, 'Wally', 171);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (455, 'Andre', 171);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (458, 'Omar', 172);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (456, 'Johnny', 172);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (462, 'Lena', 174);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (463, 'Madeleine', 174);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (467, 'Duane', 175);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (469, 'Sonny', 175);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (471, 'Lois Farrow', 175);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (466, 'Sam the Lion', 175);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (468, 'Jacy Farrow', 175);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (470, 'Ruth Popper', 175);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (473, 'Teddy Duchamp', 176);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (472, 'Denny Lachance', 176);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (477, 'Ace Merrill', 176);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (476, 'Vern Tassio', 176);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (475, 'Gordie Lachance', 176);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (474, 'Chris Chambers', 176);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (474, 'Mike Waters', 177);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (478, 'Scott Favor', 177);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (481, 'Dorothy Vallens', 178);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (163, 'Frank Booth', 178);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (480, 'Jeffrey Beaumont', 178);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (436, 'Sandy Williams', 178);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (486, 'Gradisca', 179);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (485, 'The Mother', 179);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (483, 'Titta', 179);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (487, 'Melina', 180);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (488, 'Lori', 180);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (405, 'Quaid', 180);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (490, 'Richter', 180);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (489, 'Cohaagen', 180);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (399, 'Jill Bryant', 181);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (493, 'Guy Hamilton', 181);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (492, 'Billy Kwan', 181);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (496, 'Lilly Dillon', 182);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (472, 'Roy Dillon', 182);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (495, 'Myra Langtry', 182);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (497, 'Anna', 183);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (498, 'Agnes', 183);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (500, 'Maria', 183);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (499, 'Karin', 183);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (502, 'Frances', 184);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (503, 'Vivian Bell', 184);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (505, 'Cay Rivers', 184);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (506, 'Greer Childs', 185);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (509, 'Nola Darling', 185);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (508, 'Mars Blackmon', 185);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (507, 'Jamie Overstreet', 185);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (514, 'Tina', 186);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (510, 'Mother Sister', 186);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (513, 'Jade', 186);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (286, 'Mister Senor Love Daddy', 186);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (511, 'Da Mayor', 186);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (515, 'Buggin'' Out', 186);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (516, 'Vito', 186);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (508, 'Mookie', 186);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (512, 'Sal', 186);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (517, 'J.D.', 187);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (518, 'Darryl', 187);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (364, 'Louise Sawyer', 187);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (519, 'Jimmy', 187);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (428, 'Hal Slocumb', 187);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (338, 'Thelma Dickinson', 187);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (520, 'June Gudmundsdottir', 188);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (523, 'Detective Susan Avery', 188);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (525, 'Griffin Mill', 188);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (521, 'Walter Stuckel', 188);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (524, 'Larry Levy', 188);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (452, 'John Klute', 189);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (526, 'Bree Daniels', 189);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (529, 'Mary X', 190);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (528, 'Henry Spencer', 190);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (530, 'Peggy Ramsay', 191);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (385, 'John Lahr', 191);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (531, 'Joe Orton', 191);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (532, 'Kenneth Halliwell', 191);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (535, 'Jean Brodie', 192);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (533, 'Teddy Lloyd', 192);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (536, 'Sandy', 192);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (539, 'Tom', 193);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (468, 'Betsy', 193);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (538, 'Iris', 193);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (537, 'Wizard', 193);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (230, 'Travis Bickle', 193);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (428, 'Sport', 193);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (470, 'Frau Bluecher', 194);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (542, 'Elizabeth', 194);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (537, 'The Monster', 194);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (541, 'Dr. Frankenstein', 194);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (420, 'Inga', 194);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (540, 'Igor', 194);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (550, 'Anna Schmidt', 196);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (553, 'Harry Lime', 196);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (551, 'Holly Martins', 196);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (549, 'Major Calloway', 196);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (555, 'T.R. Devlin', 197);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (101, 'Alice Huberman', 197);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (556, 'Alexander Sebastian', 197);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (558, 'Mrs. Kane', 198);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (551, 'Jed Leland', 198);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (559, 'Susan Alexander', 198);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (553, 'Charles Foster Kane', 198);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (555, 'C.K. Dexter Haven', 199);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (562, 'Tracy Lord', 199);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (561, 'Macaulay (Mike) Connor', 199);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (566, 'Harmonica', 200);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (565, 'Cheyenne', 200);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (567, 'Jill McBain', 200);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (564, 'Frank', 200);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (570, NULL, 202);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (572, 'Paula Trent', 203);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (576, 'Ghoul Man', 203);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (575, 'Vampire Girl', 203);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (571, 'Jeff Trent', 203);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (573, 'Inspector Clay', 203);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (588, 'D''Artagnan', 205);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (587, 'Porthos', 205);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (586, 'Aramis', 205);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (585, 'Athos', 205);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (584, 'Richelieu', 205);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (591, 'Milady de Winter', 205);
INSERT INTO "Movie_Role" ("Talent_Id", "Role_Name", "Movie_Id") VALUES (589, 'Rochefort', 205);
COMMIT;
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (87, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (88, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (86, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (93, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (92, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (91, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (90, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (100, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (99, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (101, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (102, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (103, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (107, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (111, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (113, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (112, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (110, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (109, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (114, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (115, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (124, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (117, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (118, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (119, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (120, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (121, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (125, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (127, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (126, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (123, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (122, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (138, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (139, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (141, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (143, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (144, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (147, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (146, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (145, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (142, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (140, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (158, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (154, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (152, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (151, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (157, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (153, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (155, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (156, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (150, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (149, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (148, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (163, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (164, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (162, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (161, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (182, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (189, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (201, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (197, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (203, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (202, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (204, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (199, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (200, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (198, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (194, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (196, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (183, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (193, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (195, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (186, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (192, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (187, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (185, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (188, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (179, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (190, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (175, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (178, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (212, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (184, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (171, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (173, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (176, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (181, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (180, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (170, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (177, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (169, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (166, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (174, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (172, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (168, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (167, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (165, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (208, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (207, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (206, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (205, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (210, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (213, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (211, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (209, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (215, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (216, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (214, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (217, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (218, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (220, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (223, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (222, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (221, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (219, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (227, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (228, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (226, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (225, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (224, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (232, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (233, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (234, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (231, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (230, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (229, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (238, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (236, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (237, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (235, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (240, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (241, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (239, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (246, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (245, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (247, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (252, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (251, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (248, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (250, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (254, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (257, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (258, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (259, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (255, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (253, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (256, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (260, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (276, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (273, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (271, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (274, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (277, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (272, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (280, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (279, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (275, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (278, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (282, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (283, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (284, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (281, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (286, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (289, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (288, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (287, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (290, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (285, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (297, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (296, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (295, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (301, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (452, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (299, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (298, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (302, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (291, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (293, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (292, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (300, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (304, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (307, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (305, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (308, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (306, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (303, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (311, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (313, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (310, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (312, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (309, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (315, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (314, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (317, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (318, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (319, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (316, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (325, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (321, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (320, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (322, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (323, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (324, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (329, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (326, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (328, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (327, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (334, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (336, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (333, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (331, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (332, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (335, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (338, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (337, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (330, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (339, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (340, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (342, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (341, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (343, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (344, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (345, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (347, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (346, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (349, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (348, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (351, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (350, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (359, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (353, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (361, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (360, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (356, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (355, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (357, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (358, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (352, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (354, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (363, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (364, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (362, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (366, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (365, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (377, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (386, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (378, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (382, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (380, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (381, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (385, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (379, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (384, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (383, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (390, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (387, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (394, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (391, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (388, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (389, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (393, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (392, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (396, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (397, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (395, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (402, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (398, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (400, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (401, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (403, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (399, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (405, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (406, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (404, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (407, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (415, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (414, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (408, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (410, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (413, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (412, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (409, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (411, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (416, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (417, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (418, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (421, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (420, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (419, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (422, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (425, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (426, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (427, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (429, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (430, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (431, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (428, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (434, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (432, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (433, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (435, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (437, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (436, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (438, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (448, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (447, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (449, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (450, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (451, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (453, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (455, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (454, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (456, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (457, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (458, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (462, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (464, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (471, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (470, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (468, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (466, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (467, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (465, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (469, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (473, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (477, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (476, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (474, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (472, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (475, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (479, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (478, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (481, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (480, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (482, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (483, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (484, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (486, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (485, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (489, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (487, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (490, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (488, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (491, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (492, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (493, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (494, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (496, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (495, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (497, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (498, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (501, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (500, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (499, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (505, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (503, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (504, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (502, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (506, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (508, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (507, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (509, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (511, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (510, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (515, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (513, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (514, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (516, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (512, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (517, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (518, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (519, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (524, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (520, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (523, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (521, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (525, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (522, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (526, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (527, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (529, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (528, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (531, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (532, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (530, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (533, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (534, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (536, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (535, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (539, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (537, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (538, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (541, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (543, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (542, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (540, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (549, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (552, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (553, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (550, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (551, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (554, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (556, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (555, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (557, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (558, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (559, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (562, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (560, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (561, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (567, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (563, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (566, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (564, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (565, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (569, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (570, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (571, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (574, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (573, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (576, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (572, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (137, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (463, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (575, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (249, NULL);
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (590, NULL);
DEFINE BLOB @'B000008c0000002900000763' LENGTH 1891 VALUE
   47494638  37614000  4000E700  00000000  00003300  00660000  990000CC  0000FF00
   33000033  33003366  00339900  33CC0033  FF006600  00663300  66660066  990066CC
   0066FF00  99000099  33009966  00999900  99CC0099  FF00CC00  00CC3300  CC6600CC
   9900CCCC  00CCFF00  FF0000FF  3300FF66  00FF9900  FFCC00FF  FF330000  33003333
   00663300  993300CC  3300FF33  33003333  33333366  33339933  33CC3333  FF336600
   33663333  66663366  993366CC  3366FF33  99003399  33339966  33999933  99CC3399
   FF33CC00  33CC3333  CC6633CC  9933CCCC  33CCFF33  FF0033FF  3333FF66  33FF9933
   FFCC33FF  FF660000  66003366  00666600  996600CC  6600FF66  33006633  33663366
   66339966  33CC6633  FF666600  66663366  66666666  996666CC  6666FF66  99006699
   33669966  66999966  99CC6699  FF66CC00  66CC3366  CC6666CC  9966CCCC  66CCFF66
   FF0066FF  3366FF66  66FF9966  FFCC66FF  FF990000  99003399  00669900  999900CC
   9900FF99  33009933  33993366  99339999  33CC9933  FF996600  99663399  66669966
   999966CC  9966FF99  99009999  33999966  99999999  99CC9999  FF99CC00  99CC3399
   CC6699CC  9999CCCC  99CCFF99  FF0099FF  3399FF66  99FF9999  FFCC99FF  FFCC0000
   CC0033CC  0066CC00  99CC00CC  CC00FFCC  3300CC33  33CC3366  CC3399CC  33CCCC33
   FFCC6600  CC6633CC  6666CC66  99CC66CC  CC66FFCC  9900CC99  33CC9966  CC9999CC
   99CCCC99  FFCCCC00  CCCC33CC  CC66CCCC  99CCCCCC  CCCCFFCC  FF00CCFF  33CCFF66
   CCFF99CC  FFCCCCFF  FFFF0000  FF0033FF  0066FF00  99FF00CC  FF00FFFF  3300FF33
   33FF3366  FF3399FF  33CCFF33  FFFF6600  FF6633FF  6666FF66  99FF66CC  FF66FFFF
   9900FF99  33FF9966  FF9999FF  99CCFF99  FFFFCC00  FFCC33FF  CC66FFCC  99FFCCCC
   FFCCFFFF  FF00FFFF  33FFFF66  FFFF99FF  FFCCFFFF  FF000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  002C0000  00004000  40000008  FE00AB08  1C48B0A0
   C1814F9E  AC58A1A2  E142872B  14463C48  B1CAC28B  0B2B567C  823061C3  8F240088
   1CA90280  8A841A07  625C9952  A3C78F23  63CA1419  91A3C695  185B524C  F8A4E1CC
   9F311DDA  348833A7  4E84555E  9604CA74  E4C2A149  8B1A3D9A  3469C390  4DB39A5C
   413086D4  8B5405BE  D44A762B  CAAF60A9  F6BC0A94  84DBB76F  456295F9  146DDAA3
   1EE7C27D  FBB1AFDF  A5230DD8  9DAAD3A3  DCBD24FE  FA75E264  2CC9C119  A9FA04E0
   16896524  8C9DA8C8  BCB871D5  2A73B70E  56BBB472  E6D3A817  43AD1214  72D8D2A8
   639FDEBC  D9B3403D  1663BA3E  EA33B16C  D97D190F  056485F5  63BB9243  92F80DBC
   2FCF2A7A  00E961A8  1B396F91  CC9B3BE7  A8478F95  15065AFE  A3954C39  BBF68F50
   1B8617A9  C2BA4EEC  E653FFE5  2A90A18A  F5ECC7EB  5C1A5FFE  DFFAD4C9  D4DE57D7
   01809A1C  7264A798  0A62DD37  936004EE  57DE810A  2A66D30A  3F0D2815  5EE5C165
   DE822789  95A17E2D  3D41D94C  6E9D8699  662A24F6  174A5500  E6948638  5DB7574C
   CB399122  5C726D27  908CF945  D8927239  22B65C5C  409D0423  90A26D28  616658BD
   B5A25B59  B5A7D24C  34D6F8A4  8ECAB598  A2665436  65656E02  66499846  21398119
   12699AC6  18935832  48A6782B  78B5521E  78A69466  669791B0  22943285  66D69CC7
   49958740  87565452  7F9A2569  D2983262  68264678  56BA518E  E6F524E8  A3E80984
   A55D8956  9A68414F  90802063  089E9A59  420C09DA  177DFEC6  D1B9929D  A2566129
   A94EA47A  5A829935  1826651F  C11A2B86  000C7668  9EB61EF4  44AEBA32  CB1866BE
   C6E56288  F58D64E2  A477E679  6B417930  9B6AB3D0  26656462  30C6686D  935F695B
   2BB7DE7E  9B2A124A  EA719897  420D5452  4931624B  69ADA312  D4ADBBAA  7249EEBC
   2D3654AE  4525F504  99BAFDFA  DB2EAF96  E9589A97  D31A4C6A  44FA662B  6AC388B6
   ABA272EC  5D5531B5  F65A05D9  0A1B23CB  EEB7A811  E9164815  43359145  27DFDAEF
   A8FF9EFA  279714BF  4C6F62C2  9270F2BE  1B1F9473  8252B2C9  23652E9A  3428C243
   5F9432A2  0679ABA6  9A37E298  98D04FB7  C7609D35  4FADACB3  1F23C99E  8B9246C6
   505543A7  AC7241A8  B68C18D3  D39AA410  CD04B55D  74FE45B1  213DAECF  05672427
   80618B6D  D0B2B119  49B14F34  8618F542  6E73CC11  E2A8293D  F7A3A2C5  F838D17B
   57FD1B5F  80333EA0  E69B43BE  2EDFB261  06178817  658C560C  6E2B4B79  E23D2BD6
   BAEB684D  2DF9EC50  0A8CD57C  5606B9F9  BA92C7F8  B9D97ED9  C7954810  3E0EBBA5
   C53B61E0  F1650EA8  A1539B3F  9F2C4579  ECF95B8B  41690851  75AF5FE4  D5F3DB22
   74287CBC  C6E6E5A3  18052F6B  E11C23CA  5FDCCDBD  5C2390C3  A72F169E  CAC19F76
   D076118E  000010E4  3B99F60E  87271D01  6067ED3B  0D5F20D2  1E03B222  300A5C08
   FAAAD640  EF656782  5E53DB21  624013C8  D8A94EDB  6AA0132A  55124CE5  4A36AB0B
   1647DA73  88409470  683158A0  A85688A7  4EE4A124  4C3B8361  E81C5292  40B08215
   D9CBE1C6  3AC14427  E0C1874C  FCE184BE  37449F54  E188AC30  8015BE33  981C6A50
   54A360E2  28F0E004  2846B185  CC01615C  5670082C  02C00A81  E0E25772  48C71804
   04003B;
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (586, @'B000008c0000002900000763');
DEFINE BLOB @'B00000600000002900000832' LENGTH 2098 VALUE
   47494638  37614000  4000E700  00000000  00003300  00660000  990000CC  0000FF00
   33000033  33003366  00339900  33CC0033  FF006600  00663300  66660066  990066CC
   0066FF00  99000099  33009966  00999900  99CC0099  FF00CC00  00CC3300  CC6600CC
   9900CCCC  00CCFF00  FF0000FF  3300FF66  00FF9900  FFCC00FF  FF330000  33003333
   00663300  993300CC  3300FF33  33003333  33333366  33339933  33CC3333  FF336600
   33663333  66663366  993366CC  3366FF33  99003399  33339966  33999933  99CC3399
   FF33CC00  33CC3333  CC6633CC  9933CCCC  33CCFF33  FF0033FF  3333FF66  33FF9933
   FFCC33FF  FF660000  66003366  00666600  996600CC  6600FF66  33006633  33663366
   66339966  33CC6633  FF666600  66663366  66666666  996666CC  6666FF66  99006699
   33669966  66999966  99CC6699  FF66CC00  66CC3366  CC6666CC  9966CCCC  66CCFF66
   FF0066FF  3366FF66  66FF9966  FFCC66FF  FF990000  99003399  00669900  999900CC
   9900FF99  33009933  33993366  99339999  33CC9933  FF996600  99663399  66669966
   999966CC  9966FF99  99009999  33999966  99999999  99CC9999  FF99CC00  99CC3399
   CC6699CC  9999CCCC  99CCFF99  FF0099FF  3399FF66  99FF9999  FFCC99FF  FFCC0000
   CC0033CC  0066CC00  99CC00CC  CC00FFCC  3300CC33  33CC3366  CC3399CC  33CCCC33
   FFCC6600  CC6633CC  6666CC66  99CC66CC  CC66FFCC  9900CC99  33CC9966  CC9999CC
   99CCCC99  FFCCCC00  CCCC33CC  CC66CCCC  99CCCCCC  CCCCFFCC  FF00CCFF  33CCFF66
   CCFF99CC  FFCCCCFF  FFFF0000  FF0033FF  0066FF00  99FF00CC  FF00FFFF  3300FF33
   33FF3366  FF3399FF  33CCFF33  FFFF6600  FF6633FF  6666FF66  99FF66CC  FF66FFFF
   9900FF99  33FF9966  FF9999FF  99CCFF99  FFFFCC00  FFCC33FF  CC66FFCC  99FFCCCC
   FFCCFFFF  FF00FFFF  33FFFF66  FFFF99FF  FFCCFFFF  FF000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  002C0000  00004000  40000008  FE00AF09  1C48B0A0
   C1818258  B058C102  80C38700  565C81C2  8AD5C18B  18336ABC  B602A2C7  8F00A0EC
   B1B8B1A4  4981AC40  AAF46885  45A068AD  4ECA34C8  2AC0CA9B  0F4BB082  1273A64C
   561D710A  05C0CA8A  209F2783  0E155AC5  CA956848  375A594A  3562A02B  513356AD
   5A6A45D6  8B29B72E  D5F3C4D4  578362AB  5AB142F2  ACA0B069  87EE8162  F6ECB5B8
   5557E8D1  63F7EED6  1524B606  7AD277AA  C7122402  3B5C0185  841E124F  9E380EAA
   18B06288  8128DA05  A96785E5  15A54A3D  F1F4E4D3  274F7BF5  94780298  AC648F5D
   FB42F1B8  470F9DC4  49E6281B  E6C953B2  64CA7EFF  4EADA7F7  5ED85EED  968298E4
   5AB2DE73  E60C13FE  5B1934EA  D48D0352  0A2050F2  B37001FE  7C82260C  BBB2F3D6
   D307C7FE  DC13203D  10F7AC80  BAF921B4  61C39051  479F1E1A  34F4D421  631C29F1
   6906DE43  24DC375D  75FCF5D7  A070C808  A847570F  59A14720  76C145C2  6FE5EDD7
   E08301A2  265A8556  D4F59586  C175281C  7FFFA9B7  5E76EE19  06C05A6D  6515DE75
   2A02879E  7FD6B5F8  A270A4A0  26A31506  9E852079  1132789E  7F4CFAC8  5E907A54
   51E11335  66F5901E  E425839F  924C4613  4D93C209  D39B760F  4151E457  41E1280C
   12D16122  CC30E879  2967709E  38F1C463  24CC41DA  720E41F1  DD591D91  708D9891
   4596446E  984C27E7  7FA4ADA0  02097A49  7667298A  C9671796  A644E4DC  1373FC06
   8D68A379  32CC9CA5  A0F6041D  A5FC562A  64A51856  D40AFE55  CA140D1D  C35C13D9
   35C8E4E1  5B299F14  571C7EE9  FD06651E  9C7A129A  1E2A9402  8DA6ADFE  39D369C2
   5CB31779  C37CF2C4  6A912593  041DA25E  C71B5958  B6468271  5802000D  5F446675
   5A32D794  82E56FD7  AE20DF5E  4E5C9268  34CFED75  E735AB3D  361A2958  0A4AD813
   506435AB  75CFFD26  A027A6F5  AAC71CF6  C2996F1E  EE9AB617  1DD18949  DA3573D8
   6AC55798  FC178D6F  C9E8C7A1  C6C2A4DC  E198BDA9  9C32CB9E  34E70934  2B60A82E
   7023B387  9DCA1CF6  16A07EC8  68EC0912  D7180BC0  593EE6A8  2380C3BC  99E22539
   46DD9BA0  BD3A8BD4  92242FCD  5F323C73  ADA7CE0A  F7465832  35DBF5DB  359DACC8
   22346EA6  DCB3742D  6217A49E  CAEC5142  5F4517DD  E1FE87CA  BC599E7F  F8613233
   80C24157  8A3204E3  ED893529  2FF8A1CA  702A3326  2684174E  5A325DD9  6CD7755C
   9B275CD3  A2FED65B  A20B62D7  9B13E7DE  8D374A7A  78FE1B7E  D3C1DE72  E910A236
   0795AB13  F4C46ED4  C13E5D83  BC89F926  D7BD95AA  879FB9EB  CE9EEF3A  56A7A5C6
   D3F50625  591F272F  50EBC25D  470726DC  0B0EFB27  1A6342C7  27A21BC7  9AE6C917
   97F075A3  77DF7D74  B74737F3  C2421265  FD404F70  FEFA9BBE  C32EB4CF  000B8D15
   AE75BF81  4C68798E  5B90FFCA  830C8001  CC0A2BA8  5E01A1F1  04047E4E  814D1306
   FDDCA587  00C42A79  F9EBD096  2E183BFC  BC6C4C51  824F4F0A  780D159C  6C845BEA
   1F6F5053  1CD2E861  2A1FCCDD  13821424  4F346E84  FE5CFBDF  1C8A139D  1B026085
   05AC60A9  C6E43789  F58C8643  949F1159  38102BA4  AA87A212  55ECCA67  BB39E441
   4F422A01  12EFA73E  CCD5B061  A74915B9  BC084653  412110AD  405FFAA8  D3ABD3A0
   F134507C  18CC9E40  A48F5D41  8E5FE989  BB5EC441  5F918B38  43F4CD98  EED41981
   20421080  FC8AAEF4  8739D4C0  8C387BE9  0DE83C51  C4EFB4E2  93AC88A4  4F9C6032
   EA946A89  301B13F9  9E33B7BD  ECA1209F  6C85203E  F995AF2D  4D38A1C1  5C2E9758
   BA06D270  05D0A0CF  4062390B  591E0529  A59803E7  9644C9DE  D14E58BD  A103FAE8
   E3A556B0  22968238  E64C76C7  20FFB80E  6CC7C2D0  2C3072CD  8A5C1329  AC68DD8E
   78049C76  2A899023  D1889C62  39C693E4  B2494D1C  DA1A8FD6  530A510A  44985099
   6756AC91  AA267D09  9F082D85  307D1210  003B;
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (585, @'B00000600000002900000832');
DEFINE BLOB @'B000005d0000002900000941' LENGTH 2369 VALUE
   47494638  37614000  4000E700  00000000  00003300  00660000  990000CC  0000FF00
   33000033  33003366  00339900  33CC0033  FF006600  00663300  66660066  990066CC
   0066FF00  99000099  33009966  00999900  99CC0099  FF00CC00  00CC3300  CC6600CC
   9900CCCC  00CCFF00  FF0000FF  3300FF66  00FF9900  FFCC00FF  FF330000  33003333
   00663300  993300CC  3300FF33  33003333  33333366  33339933  33CC3333  FF336600
   33663333  66663366  993366CC  3366FF33  99003399  33339966  33999933  99CC3399
   FF33CC00  33CC3333  CC6633CC  9933CCCC  33CCFF33  FF0033FF  3333FF66  33FF9933
   FFCC33FF  FF660000  66003366  00666600  996600CC  6600FF66  33006633  33663366
   66339966  33CC6633  FF666600  66663366  66666666  996666CC  6666FF66  99006699
   33669966  66999966  99CC6699  FF66CC00  66CC3366  CC6666CC  9966CCCC  66CCFF66
   FF0066FF  3366FF66  66FF9966  FFCC66FF  FF990000  99003399  00669900  999900CC
   9900FF99  33009933  33993366  99339999  33CC9933  FF996600  99663399  66669966
   999966CC  9966FF99  99009999  33999966  99999999  99CC9999  FF99CC00  99CC3399
   CC6699CC  9999CCCC  99CCFF99  FF0099FF  3399FF66  99FF9999  FFCC99FF  FFCC0000
   CC0033CC  0066CC00  99CC00CC  CC00FFCC  3300CC33  33CC3366  CC3399CC  33CCCC33
   FFCC6600  CC6633CC  6666CC66  99CC66CC  CC66FFCC  9900CC99  33CC9966  CC9999CC
   99CCCC99  FFCCCC00  CCCC33CC  CC66CCCC  99CCCCCC  CCCCFFCC  FF00CCFF  33CCFF66
   CCFF99CC  FFCCCCFF  FFFF0000  FF0033FF  0066FF00  99FF00CC  FF00FFFF  3300FF33
   33FF3366  FF3399FF  33CCFF33  FFFF6600  FF6633FF  6666FF66  99FF66CC  FF66FFFF
   9900FF99  33FF9966  FF9999FF  99CCFF99  FFFFCC00  FFCC33FF  CC66FFCC  99FFCCCC
   FFCCFFFF  FF00FFFF  33FFFF66  FFFF99FF  FFCCFFFF  FF000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  002C0000  00004000  40000008  FE00AF09  1C48B0A0
   C183035B  5DF1E245  90A05908  234A9C18  71162244  AC5AB512  14888B95  15205704
   08C08215  C5932809  5AB4F271  05CB962B  54A85841  2280C891  5752EA94  28082648
   99406302  004062A8  D1915D76  2A151888  05809824  A00290B9  C2A8D5AB  23572CD5
   29E3E9D5  AF60BF8E  64D16A2B  C5435355  7C551BB6  2D809182  CC4A1C5A  F52B09B6
   6EC10600  1048EE41  2B4F6982  2D9A376C  09007BFC  16A40B12  2CDEC262  03C4552C
   3030E1AF  7521EB0D  0091725E  9097357F  6571AD33  C4599D75  B655F104  5095CCA2
   ADEE2D8B  BA76699D  AC063FC9  438A1420  D8B1ADE6  4CBD5410  5827BC49  3D5B55C5
   4070AC01  049AB65D  9AF8DFB5  CA9F697F  56E5F1F3  030066FE  B54AA4B1  BC46EA11
   BB1235AA  67FB7652  8F493CF1  5E38A979  F3A82976  25419884  FBF7555C  26DF13C1
   5971CD7D  AD88871E  42520DF5  8435FF2D  57CA63AC  85561869  E42182A0  46137965
   541E112E  474A7756  CD14DC35  8924C2CA  8A087628  D8508054  1322297A  3C71196B
   C0E56591  4619B528  9150EB65  17616F79  38A14251  2A380108  819A6584  D14588A4
   485E5912  01A6167F  4246A8CA  287954F1  44155524  F75A8921  5D15A543  0E41D9E3
   44561245  422921BE  F7C71F79  E4914C6F  BE01E29A  975F8E69  9520AC08  7291A050
   92375120  53B9E9DE  2AABE0E9  E8A3A48C  42679D60  56C11270  AD408908  A11A7228
   516E6CA9  00A12ABE  E9A14798  BB251729  2973E6F1  C413FE46  E2F88415  31C8B611
   9AB8123A  11A8305A  C3AA6FAC  40B3A413  4E50A12A  A5F385F4  444C2A58  6A951581
   E69A262B  88505455  51AB40C3  2A20D9AE  A8479D45  2607AB0A  A6B2A487  155E82A4
   87551849  9B264614  B1C21F00  A5685B85  3581E40B  D2AB55B8  464A1E47  42DB924C
   60C61043  5D6A5DB3  E9A6D25E  4451BE6A  59B10A20  565803A6  B2BB8D78  2F8156BC
   BA2C5133  C53066C4  B7BA9B26  452A2C07  802CAC4C  4C8A1581  50EC651E  DCAEA087
   C5002C3B  EB6B3F55  DA2C0056  94DCB0C3  1205F284  8C376B07  E72AA594  F26D72AB
   00F00CAB  39F36B2A  987DD6C8  F12C26BF  3B911E9E  C8E85E76  BD01E268  9D539362
   E3979456  0AE6A9C9  5E936B20  B9562B51  29CA2193  EDFE7BCE  403AA276  C88CC81F
   B8E056BA  2448D0CE  9DAB4912  59E3C933  4E9002A1  76AB3E5A  45DE7D17  49027285
   575AE353  81306C32  D112F5E6  8433FF39  AD47A475  92E20CEA  53BB7A97  1361124B
   7B159FAF  102DAE74  A3497A44  813B1167  6F9DE0D9  373299DB  A802E15D  86B92409
   55ECCED1  F4BEDB2D  D1D471A6  3D4AF1AE  3F83FABF  AF6E3E4A  6F4F83AB  42E20EF5
   DEF04992  47E84CE0  DF8E8F27  E5CDCBC4  7C9879E8  A1C28A68  E6AB3EA7  27594588
   0257A44E  BCEF5FC9  A9135088  4538FCBD  4661E9FB  DFBBACD7  B808DD29  0F78185F
   E00247A4  EE00E555  72E81C98  02B13B09  3A845A8C  A388F7C6  F62D47A1  AE69447A
   95EDEAC4  B94A9190  5A5D8312  954E620D  55BC4739  FE8EF21E  07695427  5839A14F
   74BAD881  5A81C3D1  69482702  DC0EA95C  C5394FE0  A96DE3E2  DCBFC024  83030DAA
   7F757B62  4AB43536  1A01600E  C8784627  46E189DD  24892DAB  9BA2A5AC  6011D10D
   8D453BC9  D2EB9EA1  BF5554C3  1A8064D4  C4AAF284  DE4CAC52  3D5AD193  70A5C38C
   EC248ADB  799D33EA  74AA5504  6262A792  CFB1E6B8  441E516B  61EFA256  2276E2AB
   FFA08E83  5AF3126B  52450A55  B8E6540F  C9D01727  A8A651E6  317BCF40  46273A91
   87391C11  7F7AA214  1D99B8A2  626AEA22  2CF2944E  E094BDC0  EDB27394  BC588F36
   F4496416  73872961  6688EE44  234F7882  7980E852  C74A83A0  271DD33C  4A816484
   F0F62F4F  94AF732C  E9644614  29284EDD  279DD0FE  C81E9178  D3C04A7D  E43E2C2A
   E635EFF9  485CF6E6  9BDB6A9E  DBAC9093  0D952799  E82C689C  FAB6CF2D  BA0D4C80
   21278F32  D5AE46AE  6999935B  8E3A290A  884935AF  4F5F028C  2C38AA26  417D12A2
   D83CC983  B6234801  266388FC  74DB9776  0A80250A  F4A71BDA  0909AEF1  8C7CE6B3
   69ECC453  382BE531  3ECDE41A  D374A88F  5232D4ED  40031A4C  73543015  0A2B8F11
   0810D150  24941A16  D0985204  0080DC8E  3518C54E  117AD5A9  001028DD  E8594F97
   267327A7  0A294DF1  164E6435  D56324D0  03545714  885208F4  A118B9EB  4E0AA957
   EDB0D537  6D63EA7C  4A718D7C  312D10A6  085631A3  110DF194  C7501389  4641ACF1
   043F5A95  A68DEA6B  03F56012  5620B514  98852CC6  8AAE0A0D  CE4AA73C  14298568
   09B28A94  69E7AA8B  2AD5EA9E  460ACAAE  08A985BD  4658352B  5ADB0E64  16010100
   3B;
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (587, @'B000005d0000002900000941');
DEFINE BLOB @'B0000088000000290000085a' LENGTH 2138 VALUE
   47494638  37614000  4000E700  00000000  00003300  00660000  990000CC  0000FF00
   33000033  33003366  00339900  33CC0033  FF006600  00663300  66660066  990066CC
   0066FF00  99000099  33009966  00999900  99CC0099  FF00CC00  00CC3300  CC6600CC
   9900CCCC  00CCFF00  FF0000FF  3300FF66  00FF9900  FFCC00FF  FF330000  33003333
   00663300  993300CC  3300FF33  33003333  33333366  33339933  33CC3333  FF336600
   33663333  66663366  993366CC  3366FF33  99003399  33339966  33999933  99CC3399
   FF33CC00  33CC3333  CC6633CC  9933CCCC  33CCFF33  FF0033FF  3333FF66  33FF9933
   FFCC33FF  FF660000  66003366  00666600  996600CC  6600FF66  33006633  33663366
   66339966  33CC6633  FF666600  66663366  66666666  996666CC  6666FF66  99006699
   33669966  66999966  99CC6699  FF66CC00  66CC3366  CC6666CC  9966CCCC  66CCFF66
   FF0066FF  3366FF66  66FF9966  FFCC66FF  FF990000  99003399  00669900  999900CC
   9900FF99  33009933  33993366  99339999  33CC9933  FF996600  99663399  66669966
   999966CC  9966FF99  99009999  33999966  99999999  99CC9999  FF99CC00  99CC3399
   CC6699CC  9999CCCC  99CCFF99  FF0099FF  3399FF66  99FF9999  FFCC99FF  FFCC0000
   CC0033CC  0066CC00  99CC00CC  CC00FFCC  3300CC33  33CC3366  CC3399CC  33CCCC33
   FFCC6600  CC6633CC  6666CC66  99CC66CC  CC66FFCC  9900CC99  33CC9966  CC9999CC
   99CCCC99  FFCCCC00  CCCC33CC  CC66CCCC  99CCCCCC  CCCCFFCC  FF00CCFF  33CCFF66
   CCFF99CC  FFCCCCFF  FFFF0000  FF0033FF  0066FF00  99FF00CC  FF00FFFF  3300FF33
   33FF3366  FF3399FF  33CCFF33  FFFF6600  FF6633FF  6666FF66  99FF66CC  FF66FFFF
   9900FF99  33FF9966  FF9999FF  99CCFF99  FFFFCC00  FFCC33FF  CC66FFCC  99FFCCCC
   FFCCFFFF  FF00FFFF  33FFFF66  FFFF99FF  FFCCFFFF  FF000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  002C0000  00004000  40000008  FE000309  044410D0
   C0820405  062AB810  2142850F  0F326C48  500F203D  183362B4  624561C3  85100D7A
   1C3990A2  C393282B  22D498D1  8A1E921E  0D8A8429  9320C727  2B563CE1  683125CA
   9E163572  B4323364  5191090F  EAA9B242  05000024  9EAA5851  A58ACB88  3F59EAE1
   79B56849  981E7BE6  7C4AB62C  00155379  FA04DAD2  A5CB975E  63820459  D1CA9327
   4ECDEA7D  4AA26AD7  9517836A  C54833A6  573D3AD1  EE5D7CD6  AFCAC142  B712064B
   B94A5EC6  98493CB1  FA5630E4  AD1C29D3  7C82B974  591256AC  7E8EEC52  34C915A6
   63F3A5AA  7A35E897  AE3D4695  2D5B855F  C85C27E7  5EC8BBF8  E62AB687  0E1758AA
   38EF1576  3B03EF58  8AB9C2EA  D5213AE7  AD67A764  96D203FE  65BF8E7D  3CA0EDB2
   51EF742B  B97368F1  1E4BC987  AF10BD6C  BBC823B7  852F7F7E  7981AB58  615F6C9B
   3D31D850  1CF5D79F  780B0258  05632444  48025A68  ED169B6F  06B22754  820AF2D7
   60297A2C  46821324  96E8045E  2A58581A  62D37178  1D79FE35  A7D78826  CA616389
   29C6C622  823C72A8  608CF4B1  B2971336  DA38C71C  791C4962  85A621D6  638F3F46
   395F2042  9A35A291  476639C7  894E3089  9993ED6D  688594E5  4D59E569  4416A9E5
   914FE0C8  57542A02  E064706D  8D49E68F  54C28666  91586A69  628A145E  F654771A
   8267E79D  0C06B28A  9E64A5C9  E7A32676  19A8A072  AE87A056  7832D7A0  78E79145
   C21C8F86  1AE9A482  FA869C7B  5CB9685D  993132EA  4427FE37  22814489  458E3A69
   5977B9A5  6B7BAD91  C9A07CA4  04EBC483  00E49187  13714648  E49F123E  C5685F06
   6EC413AF  7ADCB920  B0A4A810  22009DE4  9162B36F  9A18A759  B95EAA6B  67D6FE48
   0AACDE92  40CA5D4F  58F8AD0A  5C526A56  15960E65  2846E92A  18EC9623  E621C71C
   77AD1055  BC346E69  6F593BEA  FB59BABF  06DBA60A  72089CE4  5D92D24B  E2B151E9
   A9675E4C  DDD6D260  D67AF8AF  13A01689  C7B191A6  892C5F50  45A81853  805C6AA8
   4BFDF6F7  AFC05986  2AAA8412  5218A15D  A0D1791B  CEFD8A17  6C1EB00E  7CA4CF7C
   222BF3A4  24E8C459  8F450F95  33B6483A  BD26D452  6B9C71D5  D0D9FCE4  565B07B2
   74925E1B  0936A038  5688D393  741F0A71  294BA3DC  F3FE8D8E  D68AACC6  93CE5D37
   945B63FB  C4DEB4F2  092A89CA  4E3D614E  8313EEAB  7F4A77F7  B49124FA  5D22D08E
   431E398F  85E34D4A  927B47CD  2CD015A2  25F8E75A  93196C79  C192F235  DF5B6ECE
   B9CC13AA  B03AEB76  238AEDB2  276A2EEE  ED134698  53D9BCF7  DEE1780B  91E28989
   6DCAB1F9  13C7225C  FC5942E7  942FEB51  6ACA9FD2  C7CA8171  9B24127C  A2813AE1
   0595D053  21FFE415  565CB187  157BD4DF  BD820681  68F0B1E6  D728FCB7  B9FBD6F1
   0627BF3D  04C28007  BCD694AE  23A0A73C  EF7C91F2  9BAC9010  B46F01C0  73EFAB1F
   4C10C5A0  B2748244  F012DBF0  5007C09C  40A14757  48210205  C14253B0  5010FF61
   9EA270C5  327875A9  65A9ABD0  6E06C8A3  14CA2F10  FE2F6C85  1087D8A1  91AC625B
   4F111808  6D28C225  052A4264  C1E0507C  08444108  F11A58C4  6234E863  98523C8B
   48360C61  CB96D42C  0B49317E  F213C420  AE98C52C  D2043150  8C190823  7517B4D8
   2A8E9739  630AF9A0  C656B4B1  8DD6D98A  C160F6A6  5995887C  21D421B8  A06216F7
   A1918FAD  88C61FDD  18082B0C  F2349E52  D6189D38  2E4636D2  7D2AB4A2  1F27790D
   38C5D153  9E4C9121  CF072F14  0110688C  2941D942  394A529E  B2936FA2  512B1349
   425C96A5  042C881F  24498945  5F123266  F4DA2527  8376CAD2  AC800590  94242963
   0345091D  9297542B  4E000260  05415CC3  1AD69824  2633A349  5B91CA98  8C09C015
   AE018D70  B6D13923  CA5DDCEC  28347462  060AAC44  00E73B9D  734340A1  688E161C
   10549EB0  8A6F86D3  4AC9324B  C602D5CA  570AF429  25800234  A0718D26  59895E14
   3AE44273  F4508876  D334A4F1  240024B5  49377594  2CDB0C08  003B;
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (588, @'B0000088000000290000085a');
DEFINE BLOB @'B000008d0000002900000920' LENGTH 2336 VALUE
   47494638  37614000  4000E700  00000000  00003300  00660000  990000CC  0000FF00
   33000033  33003366  00339900  33CC0033  FF006600  00663300  66660066  990066CC
   0066FF00  99000099  33009966  00999900  99CC0099  FF00CC00  00CC3300  CC6600CC
   9900CCCC  00CCFF00  FF0000FF  3300FF66  00FF9900  FFCC00FF  FF330000  33003333
   00663300  993300CC  3300FF33  33003333  33333366  33339933  33CC3333  FF336600
   33663333  66663366  993366CC  3366FF33  99003399  33339966  33999933  99CC3399
   FF33CC00  33CC3333  CC6633CC  9933CCCC  33CCFF33  FF0033FF  3333FF66  33FF9933
   FFCC33FF  FF660000  66003366  00666600  996600CC  6600FF66  33006633  33663366
   66339966  33CC6633  FF666600  66663366  66666666  996666CC  6666FF66  99006699
   33669966  66999966  99CC6699  FF66CC00  66CC3366  CC6666CC  9966CCCC  66CCFF66
   FF0066FF  3366FF66  66FF9966  FFCC66FF  FF990000  99003399  00669900  999900CC
   9900FF99  33009933  33993366  99339999  33CC9933  FF996600  99663399  66669966
   999966CC  9966FF99  99009999  33999966  99999999  99CC9999  FF99CC00  99CC3399
   CC6699CC  9999CCCC  99CCFF99  FF0099FF  3399FF66  99FF9999  FFCC99FF  FFCC0000
   CC0033CC  0066CC00  99CC00CC  CC00FFCC  3300CC33  33CC3366  CC3399CC  33CCCC33
   FFCC6600  CC6633CC  6666CC66  99CC66CC  CC66FFCC  9900CC99  33CC9966  CC9999CC
   99CCCC99  FFCCCC00  CCCC33CC  CC66CCCC  99CCCCCC  CCCCFFCC  FF00CCFF  33CCFF66
   CCFF99CC  FFCCCCFF  FFFF0000  FF0033FF  0066FF00  99FF00CC  FF00FFFF  3300FF33
   33FF3366  FF3399FF  33CCFF33  FFFF6600  FF6633FF  6666FF66  99FF66CC  FF66FFFF
   9900FF99  33FF9966  FF9999FF  99CCFF99  FFFFCC00  FFCC33FF  CC66FFCC  99FFCCCC
   FFCCFFFF  FF00FFFF  33FFFF66  FFFF99FF  FFCCFFFF  FF000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  002C0000  00004000  40000008  FE007F09  FC55AC18
   B1830795  295496AC  A1C387C9  9E499C48  5122C48B  0B95213C  5870A0C7  821B892D
   BCD8B022  4567289D  999C4832  D9C2901D  3F1ADCA8  90E4CA94  3873A25C  495221CC
   62034122  1C7971A2  CEA34853  B2C4E813  6147A109  6B42349A  D419B5AB  58ABAAB4
   08F1A553  A822A53E  9CC82A90  1556D7CA  AA58BB16  10A0152B  CE62BD7A  74E943AF
   1C698A2D  2911A595  2A5556AC  75A28230  89B54FD8  B2851B97  155D9C76  1BE2D5CB
   706CDF40  8002AB20  7158C593  2A240028  1E3C5A85  5C6A3923  BB6CAAD7  F2336781
   9C655EC1  1980E827  4E9C00E8  9C78B061  CE6C4FA7  E62A5963  6B8754FF  060E6D7B
   77EED02A  AAE4DE7D  9879F3B5  56023946  0D99F8EA  A19591FE  BF46B9A2  4A62E6CC
   138BA642  588568EB  CD6D33CF  BEBD7B57  8D7B238E  0F2418FE  75E66BC5  27E080CD
   ADA0DD63  3B3D73DF  5E7DC106  4880031A  46A07F04  0A28977D  0E11251E  4A7A8036
   E1661586  18E20A5D  38A69482  7785A75F  4AE70DC8  1970208A  286320D3  4C935582
   77598653  8C029290  5B6E4F50  28E38056  D488E056  2D356895  7B2ECA81  C79379E0
   36A48C71  D988A077  1BA274D5  833DE6D1  89934F3A  E1E19421  1E60E495  2866A925
   35AB5411  1F099D1C  C3092778  70D2491E  55F048E6  80355A89  215F2961  65CD9800
   C4C98925  7376324A  1E7940B8  27816772  87247281  5E55638B  241C13CC  9C9C0473
   8CA27938  D1DBA37C  46AA949A  96D658CA  5A3E1E03  0CA7FE9E  1E33CA9D  A22A466A
   737DA209  E89A7D42  E3848F75  72CAC931  C4CEFA24  1E3FF626  A488B94A  CA9592A9
   EAE11E09  72C8092B  B19D64FB  251E7238  2147B7B9  6DB66C7C  559E79E2  AE58A9AA
   1B09760A  0B0CB1D8  1E0BE6B7  3FEA59A1  0C7D5AC9  DDB395F6  09C81FBB  CD2907A7
   F07E9A28  B7C7221B  2E9332E2  DBECA9D0  52D36735  AB70D689  B073C28B  F1937472
   BBF0B805  E68B66C4  F942E323  C6C3C27B  31CA4F82  6B2F81AC  B022B2B3  54592571
   9FD700E0  C4CA04AB  8CF1C59D  282CEE8C  F99A9B60  83E9F6E9  269C8772  1A27B63F
   771C6E6D  22AE50B4  BE47F7DB  A735EB5A  3B2730B1  6ABA72B6  C104ED32  C3211A70
   B59F096A  DDA71EBB  19EC74AC  3CCBD149  D91EB787  36FE8145  5E8DA6DB  3592129A
   A189F2CC  E9B7D9E6  CD2AC800  C4B0F6DF  BCE64BCA  AF7920F3  6DCB3F7A  FB2D98F5
   32DE9C99  7ED33C5E  D235B6A9  421ECE28  FC6B732F  16361DA9  812012FA  BE35A75A
   233454E4  EECC1FCF  514842EE  7B4FC9CA  2CA19F48  32CEB9EF  BC28159E  3D215F68
   4E20438A  F3A4AECD  F656C7F7  F9C41378  287A6715  8C0EE663  1E12E571  ABF5BA8E
   6773D14F  7899F228  8B32FAEB  CEC720F3  8CF9D53F  EE2CBAB6  4FC3E831  032BD6A2
   5A56ADB2  398314AC  DBDED02A  A43FDAED  6A7D7D5A  451E00F8  3459CDEA  5BD83A86
   33E4201F  46E1E637  ACB34DDF  8AA6AB15  45AE46D6  98E0C02A  A82D4F5D  4C83F803
   8097F2D0  2D050AC8  40FA3B97  0921D8A7  51046360  FE292B98  D8E2E48C  D5E9CC6C
   B9C95368  5E540599  150F4725  A9D4CD6A  F48CA071  0218EF2A  D8A6B285  1223C2A9
   139D1390  0AAE31BB  53A1CA76  D0780629  06163639  218B13A3  50C9EA96  18460101
   A28C507C  200FAF01  8D550C0C  6CC1285B  B790F029  6438230F  2F620E12  8C181F2B
   ACE28979  7C20E9F8  58B76F21  410EC8F8  920727E4  9FECE071  525351DF  2447C1AD
   CD754B83  99FC5185  FC432312  96B028EA  E3E1349E  71B9CD69  2B5B9E08  5288E093
   431D4A46  476B9A22  34262730  3BDD124F  D41BD227  BD939F88  DDEC1AA5  E058B638
   71B93089  C973AEA4  D9828019  CCDB91A2  4E7102D7  8F7CA41B  65364B52  A05C4D33
   6339976B  902251A3  10E738A9  C62C7DA1  134B3EFE  59274EE6  B20A697A  EB4E7398
   43E68227  207BFEA9  38E0714D  4EAE324C  79D9AD13  73A0D78B  647423E3  A528240C
   529296AE  E1C7CDD9  A994BD63  8E600874  24EC5D14  A3EB8CA5  33A051CA  15D26BA0
   8541E49B  6C339C34  15C73828  55917E62  790D275D  AE6333CC  037B9C80  07993ECF
   36B139DA  82363293  A8E874A7  29914344  4B992DF8  712B68AA  DC8D8502  A11A7532
   152C1A12  CF78BE45  4DB26A8B  A8A4248C  7C06649A  6AD8F4A6  5F254853  C3F2D49D
   760BABC7  C2AA13F0  B4C41101  82293825  464CE48A  529B3C03  0F24805F  E6C2F59C
   B5564805  5BF86B86  022B58A0  C824A710  0904F5E2  684D7125  724880B1  8257E3EA
   11818085  AE0C6185  156C5318  F8250E59  F4240B93  0AE01208  CA0EF617  0101003B;
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (584, @'B000008d0000002900000920');
DEFINE BLOB @'B00000610000002900000929' LENGTH 2345 VALUE
   47494638  37614000  4000E700  00000000  00003300  00660000  990000CC  0000FF00
   33000033  33003366  00339900  33CC0033  FF006600  00663300  66660066  990066CC
   0066FF00  99000099  33009966  00999900  99CC0099  FF00CC00  00CC3300  CC6600CC
   9900CCCC  00CCFF00  FF0000FF  3300FF66  00FF9900  FFCC00FF  FF330000  33003333
   00663300  993300CC  3300FF33  33003333  33333366  33339933  33CC3333  FF336600
   33663333  66663366  993366CC  3366FF33  99003399  33339966  33999933  99CC3399
   FF33CC00  33CC3333  CC6633CC  9933CCCC  33CCFF33  FF0033FF  3333FF66  33FF9933
   FFCC33FF  FF660000  66003366  00666600  996600CC  6600FF66  33006633  33663366
   66339966  33CC6633  FF666600  66663366  66666666  996666CC  6666FF66  99006699
   33669966  66999966  99CC6699  FF66CC00  66CC3366  CC6666CC  9966CCCC  66CCFF66
   FF0066FF  3366FF66  66FF9966  FFCC66FF  FF990000  99003399  00669900  999900CC
   9900FF99  33009933  33993366  99339999  33CC9933  FF996600  99663399  66669966
   999966CC  9966FF99  99009999  33999966  99999999  99CC9999  FF99CC00  99CC3399
   CC6699CC  9999CCCC  99CCFF99  FF0099FF  3399FF66  99FF9999  FFCC99FF  FFCC0000
   CC0033CC  0066CC00  99CC00CC  CC00FFCC  3300CC33  33CC3366  CC3399CC  33CCCC33
   FFCC6600  CC6633CC  6666CC66  99CC66CC  CC66FFCC  9900CC99  33CC9966  CC9999CC
   99CCCC99  FFCCCC00  CCCC33CC  CC66CCCC  99CCCCCC  CCCCFFCC  FF00CCFF  33CCFF66
   CCFF99CC  FFCCCCFF  FFFF0000  FF0033FF  0066FF00  99FF00CC  FF00FFFF  3300FF33
   33FF3366  FF3399FF  33CCFF33  FFFF6600  FF6633FF  6666FF66  99FF66CC  FF66FFFF
   9900FF99  33FF9966  FF9999FF  99CCFF99  FFFFCC00  FFCC33FF  CC66FFCC  99FFCCCC
   FFCCFFFF  FF00FFFF  33FFFF66  FFFF99FF  FFCCFFFF  FF000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  002C0000  00004000  40000008  FE005909  1C48B0A0
   41818802  29B46245  A1424108  11498C28  B1A2C58B  180F1A84  78706195  1520413E
   D1030850  208A1853  4A1424E8  22478D03  11113CB9  500FC390  219F5831  A9E7A445
   562A2BB2  5CC99225  CC823E59  350CC490  E1931524  004825B1  E289D52A  4B6502C5
   58B4AB57  A3471172  5C680567  54A95271  E60CB44A  66CAA288  E0121574  322C2B2E
   566C5AD1  F9F1A3D9  B46AAB62  0D2454E8  D7A18702  D17D0993  69153D57  AD5A554B
   35F053C1  59E37ED5  7C9831D0  81105705  C25A9644  D99C6A55  A840FD54  72952A0E
   37733E1C  532B2B96  0A0131F4  BB0240E5  C02B54AB  8D2CD9A4  62AF873A  2B4C793B
   B79E151F  57FF060E  52F56A90  559E607D  5D7569E7  CE15B7FE  6A666A25  FB93EB24
   CEA64D0F  15E4749C  A45F3334  FEDDEB4A  535EC9EF  854A152D  60B3C1BD  2752797B
   35455F7D  43C5851F  4B0B3255  557BEE81  341580BD  51C51B76  056AC7D0  7208B6A4
   9C834F01  90D76521  5E575D70  BE953559  484EED45  5A6C1D7E  E5D05E97  9104881E
   D995B5DA  652101A0  42791F9D  27927657  3545588C  322E6415  097A9052  4A29A4DC
   A813742B  3EA51A64  0FAA15A4  7CDE2189  9B43382E  F96432C9  3C792364  2B0E47E3
   70D04147  A0495E7E  A9108E7E  9592CC33  763EA9C7  9EDAB1F9  63761786  F41120F2
   C118636E  8472F784  9D78E259  0A20A4D0  19286A12  0EA75381  C61DD7A1  73907DA4
   879D643E  532629A4  E288A570  594E0640  483B42B7  5D4FFE0F  21E85020  A6D6082A
   996526D3  A4A4C299  48A5AF81  613AABA6  F9397463  1E7AA8F0  14A4B836  1BE99E55
   E461A548  8209991A  76180EFB  E19C7C4E  3666B3B9  467AE363  E6F1F81A  095500BB
   2A861BC6  DAD5B081  9CF99A98  79DE0AA5  B8D0CE3B  EDB942AE  A8020993  C1B614B1
   721A0BED  7E00DC4B  EAC2A48E  ABDD9E10  FB751A89  E5458821  AC302A06  2F49745E
   560A9F4D  322C6953  1087F95C  70A739F5  2F7C03C7  062F9889  D6A99755  76963A59
   203835F5  98B9F1AD  D6EA0A2D  670CEF4E  3B4385F3  0A5D80A4  079EA4C8  57052BD4
   E615F165  ABBDE6D7  BA6D66FA  D0CB6062  159C0ACF  35049215  CF442A35  490C41FC
   6C1EFAAE  E662A563  0FC6F5CB  364507B6  4D7A0152  76FEC967  EE09C8BD  D0A629D8
   6AAB56DD  EEDCC3EE  16E0A77D  97F2CC9E  E23E29F9  93A5EA21  ADCFAAAD  58789B87
   234ED665  24D4EB24  99902F2C  793222F3  E9737059  FED667D0  88572C21  A8A77F0C
   F9AD6402  BE27DBC1  A22AE80A  31783E6B  79AAAE82  EB98CFEE  E909EEBA  5B9E9D5A
   5690006C  48C22F94  E85324AC  423B29A2  96DCE4AD  A47A0231  DB4FF9C5  E3D76A61
   1CBB6E92  A9B03DF7  B6EF1E29  C3E28FFF  FC89D8A2  7F1DEC5C  EF36E5A7  502249A4
   CAB52B3D  78A272C8  725E9AA8  F233E855  CF23535A  D4B39EF5  30E5D5CF  7BBB7BDE
   75D635BD  EE3CD031  8A8B9F93  FA76C00B  62D07993  1209D694  25B70736  45451394
   1C290E58  B2C740AA  646CF38B  AF78B43A  AB7C503F  FE405B41  BC302899  D694AE86
   F7631DB6  80A59D1F  06624A65  B1C2A39A  B6A739A0  E96C05CC  601221D4  272562C7
   89FE2B4B  F3A085C1  0BE62187  5509916F  5A43B536  3D018CFB  F1544922  86451C46
   AC5C6ACC  921E3FC2  3FCFDDA4  7C363A21  06CF483C  2285E837  8012D29F  9C18AFB2
   006A0502  6458E54A  06A4ABCC  AB370660  1D208258  9DCE55EF  0ABB0152  553E25C9
   E4E9CC35  56C3DE89  A268A2BC  30329471  5C01E516  06312059  CD6A9584  10B6AC05
   34469245  71C119C9  098977CB  176E7148  D3EAA52F  9B1230D6  BDD09696  7C26F1AA
   533EECA8  C0474053  5FF5BAF0  42168584  2A23B125  2ED3A697  49B50624  06705B1F
   E7664C6A  05E659CF  F45E2EAB  C39D3639  739D2FFE  DB4D2AA9  F58455AD  2A5E7D1B
   E6347142  24B53811  94FBD152  55CE2244  800AB29C  E71B52BA  58243C84  8E2DA255
   818284D2  92A93942  EC4CFEC3  89DB82B8  BFD889F4  9B6CDAE8  AA482239  8096648E
   CC0C5617  81D6C7D3  9C086BEB  428B8EFC  03C9BF4D  6E613075  8A4C79C3  94975DEB
   3F50414B  55AE794D  8EFA7472  4F1A625E  6E22D26A  B20876A9  69EA54D4  D3237FAE
   6A274F85  AAD9F644  55CBA06F  05996C59  60B4CA53  56E51400  2309AB58  F1362E2F
   F606272B  04405A8F  669DDEF8  A7AD77AD  545EA04A  58BFD18A  375843AB  4AD16280
   C6B2EA3A  6CE5A974  AA232200  12567B8F  32CE8DCA  A2D41E2D  D63F26FA  CF5FD1A2
   2E115D23  10844DAD  5401EBD7  D1761645  381D146D  6A747A8D  D3A696B0  0E022D5E
   FF6A00C6  AA202000  3B;
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (591, @'B00000610000002900000929');
DEFINE BLOB @'B000005e00000029000008eb' LENGTH 2283 VALUE
   47494638  37614000  4000E700  00000000  00003300  00660000  990000CC  0000FF00
   33000033  33003366  00339900  33CC0033  FF006600  00663300  66660066  990066CC
   0066FF00  99000099  33009966  00999900  99CC0099  FF00CC00  00CC3300  CC6600CC
   9900CCCC  00CCFF00  FF0000FF  3300FF66  00FF9900  FFCC00FF  FF330000  33003333
   00663300  993300CC  3300FF33  33003333  33333366  33339933  33CC3333  FF336600
   33663333  66663366  993366CC  3366FF33  99003399  33339966  33999933  99CC3399
   FF33CC00  33CC3333  CC6633CC  9933CCCC  33CCFF33  FF0033FF  3333FF66  33FF9933
   FFCC33FF  FF660000  66003366  00666600  996600CC  6600FF66  33006633  33663366
   66339966  33CC6633  FF666600  66663366  66666666  996666CC  6666FF66  99006699
   33669966  66999966  99CC6699  FF66CC00  66CC3366  CC6666CC  9966CCCC  66CCFF66
   FF0066FF  3366FF66  66FF9966  FFCC66FF  FF990000  99003399  00669900  999900CC
   9900FF99  33009933  33993366  99339999  33CC9933  FF996600  99663399  66669966
   999966CC  9966FF99  99009999  33999966  99999999  99CC9999  FF99CC00  99CC3399
   CC6699CC  9999CCCC  99CCFF99  FF0099FF  3399FF66  99FF9999  FFCC99FF  FFCC0000
   CC0033CC  0066CC00  99CC00CC  CC00FFCC  3300CC33  33CC3366  CC3399CC  33CCCC33
   FFCC6600  CC6633CC  6666CC66  99CC66CC  CC66FFCC  9900CC99  33CC9966  CC9999CC
   99CCCC99  FFCCCC00  CCCC33CC  CC66CCCC  99CCCCCC  CCCCFFCC  FF00CCFF  33CCFF66
   CCFF99CC  FFCCCCFF  FFFF0000  FF0033FF  0066FF00  99FF00CC  FF00FFFF  3300FF33
   33FF3366  FF3399FF  33CCFF33  FFFF6600  FF6633FF  6666FF66  99FF66CC  FF66FFFF
   9900FF99  33FF9966  FF9999FF  99CCFF99  FFFFCC00  FFCC33FF  CC66FFCC  99FFCCCC
   FFCCFFFF  FF00FFFF  33FFFF66  FFFF99FF  FFCCFFFF  FF000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  00000000  00000000  00000000  00000000  00000000
   00000000  00000000  00000000  002C0000  00004000  40000008  FE00AF09  1C48B0A0
   C1830813  2A5CC8B0  21A281B3  AE456C48  B1E24156  81B8040A  8428908C  151F57AC
   B01208E1  AC931653  1264B582  15C64022  57942001  20664C19  5658A9DC  29106397
   15076AAE  88611380  50A10684  8A0CA493  27C52EB3  48AE3060  7385D115  34AF1ADD
   5AD50AA2  8813139E  44E99065  CC1255CF  D24C2B72  6BCD185C  0E85755A  1011DB91
   77BB5A75  2B946449  BA2BADA4  152C52F0  93154F08  DB7CA274  AF522B56  048E9D0C
   96ACC28F  8D172BCE  BBD9A6E2  C880B91C  88098004  09915520  5BA9C29A  F59327A9
   57DFD51A  D3CADC8A  2743A64D  AC470FA0  DFBE7F03  EA0DBCF7  6AD77B93  8B845A79
   AC6484B2  10292D81  B670F0DF  A4B26BDF  4E4AF870  E33193FE  DA64759B  21CBCCA8
   7F975ACF  3D7BA9ED  D7BFCB6E  5BB56943  5682011C  9859BD30  76F7A4AC  27207BDB
   09D79B1E  8411D5D5  43945926  D0215D18  95D4559E  01520A20  EE0DA8E1  7BDA6108
   9C1587B1  05C55F0E  06C69750  24104612  871BB6A8  1D7B07AA  A8DC48B2  2C44D289
   31417198  1516B6E8  23871D1E  68557E49  8DB64217  3A5146D0  1E56B8B5  42008B8D
   A4878F01  6E586071  7A547114  5722D957  22640004  70624DC7  F906647B  559ED9DD
   81C66D49  E10A7F1D  24CB4754  4DC5D70A  3A5AD15B  861AA6C9  1E81DF81  E7A69191
   29295120  441A1514  9788F9B6  DD8F2EB2  995F4D8C  AE20D164  026D34E9  98423D11
   5F8F900A  488AA484  B9191342  5DE0E4D8  98A8F946  AA9EFEBD  B5681C14  792A4661
   63B390E7  9C44D7E0  C4A952AE  BE16624C  B0396A60  15C3A655  299C2561  5AD0AFE9
   E9C11B88  8B55419C  7C55D804  856A87D1  1653B3CE  122403AB  22F5E629  71AB1D26
   AC9E0122  48AC6A90  B96BD5BC  B5CD92C8  23F89617  08AB259C  EBEA6A90  8924ACA7
   EB498BD8  6B8205AC  DABC4A05  D26079AC  90CBE387  2126DCA8  A7D9E981  D84801C7
   145B555D  20692841  13FDB470  5F068208  2F88D65A  8BA1B408  AFBCC2C7  B5718124
   2BAD8C5C  100BD206  A88294DE  B139DC6A  E61A9BED  B6F12208  6BC050C0  09552B39
   EB5C104B  C98CBA94  871D066A  DC9EA3C6  A61A9BC6  29E652D4  0D1A3411  D5C9E8A1
   821517FE  979D7758  EAD1B5CA  D7162795  60AD2082  48FE2264  EF8AD013  D0683C52
   DBDD7548  8A2719B3  598AD2A9  092D9FC6  90CDA2F7  DE7D9747  10DBAF21  F61E8655
   A279A085  8040E6AF  81C6C1B4  0222633F  6CF940A5  04A282E9  906AF779  80A4A40B
   2BE8319A  CE8ADE89  DC5BB642  88067258  EB54BA7A  A08059B2  F6F98701  333579EF
   952F845F  29A96D14  A9DC59BE  06C8461A  177B6D8C  085EB37B  22AAAF4E  90F5DD05
   32A0EC72  7B222D82  F0D70676  D824ED4E  B9EA0D05  B2C785D6  FFA935D8  90694DE3
   88A3B4FA  4D8E7750  EBDB7DD4  B73DF589  CA780094  0FC0E235  34C8D80F  81F863C8
   2C64F091  556C4F54  708B1B00  6145BF0B  F2AD727E  5B88E498  F51BF5AD  C938ADA1
   95159006  2F5785CE  0A5D38E0  E41208B5  14324410  FE1B09C4  072F94AE  81098B2D
   13BBE101  4F583E8B  CC2288EA  69DBE3C0  462B845D  473526EC  61061582  A9436CA4
   856EC392  6A68181F  2CEA706F  D0E3A1F9  10F212EF  BC8D7322  045B0573  62BF13A2
   D087E6F9  62083997  B8CF8DD0  80894084  169BC8C5  4B9DA415  411422DC  DA13B7A5
   59F08CBD  4B84AEA4  A6413D2A  52917C04  528C56C6  94F1F170  90945421  14852344
   45BE6771  B41B5A01  AD700859  8CED8EBF  53214A30  B21E4C9A  4938EB81  1BFDAC20
   83439C51  6F6A0CE5  41CEE6C0  0BD93084  D7592564  64B0C456  04328D28  4C092D05
   F43F4929  7365A843  5D0F6189  C78250A6  231B52E5  CAC6F935  C8742191  BE04E627
   C3253D44  ADA24550  DC2439E5  8328BF6C  E4102ED5  C1593435  28BA7796  C29F3E4A
   E487BE47  127B0AD1  8B938CE5  30258288  7EAEE79D  FE2CE63F  A92944F8  6DEF377E
   2928A230  823A7D0E  327F0983  E82A002A  D1015DB4  377B08A2  1E361AC4  2E3CF295
   0A148BF8  6012BA01  8D345498  1C8E4A43  972B561C  C26674CC  A7424936  108C5821
   1A5312D0  4D031A34  300A2732  AC706547  822A3959  C4542118  B9C2351C  78D3A50A
   C881A4C4  2426E928  0B57BAC4  8BD78886  40B2E9BB  3CFE2510  238DAB57  A9D9C04B
   E6727B3A  896A4F5D  5292A6E4  53AF0C41  045A7B72  88B8864A  8A5F2591  2C4E52D6
   5CC569B1  7F654540  00003B;
INSERT INTO "Talent_Photo" ("Talent_Id", "Photo") VALUES (589, @'B000005e00000029000008eb');
COMMIT;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 111);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 115);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 118);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 121);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 124);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 127);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 129);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 136);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 137);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 138);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 141);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 157);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 159);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 160);
#INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 161);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 162);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 164);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 165);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 166);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 169);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 170);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 171);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 172);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 174);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 175);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 176);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 177);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 178);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 180);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 181);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 182);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 183);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 184);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 185);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 186);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 187);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 188);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 189);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 190);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 191);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 192);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 193);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 194);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 196);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 197);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 198);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 199);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 200);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 202);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 203);
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 179);
DEFINE CLOB @'C00000590000002a000000cb' LENGTH 203 VALUE
   44616E3A  20546869  73207761  73206D6F  73742063  65727461  696E6C79  20612047
   206D6F76  69652E20  52696768  743F0A0A  43726169  673A2053  6F727279  2C206D61
   6E2E2020  49206368  65636B65  642E2020  49742077  61732050  472E0A0A  42727563
   653A204C  75636173  20706572  736F6E61  6C6C7920  77616E74  65642069  74207261
   74656420  50472062  65636175  73652068  65206665  61726564  20746861  74207669
   65776572  7320776F  756C646E  27742067  6F20746F  20612047  20726174  65642061
   6374696F  6E206669  6C6D2E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000590000002a000000cb', 101);
DEFINE CLOB @'C000008e0000002a00000031' LENGTH 49 VALUE
   54686520  476F6466  61746865  72206B69  6C6C7320  65766572  796F6E65  20616E64
   2072756C  65732074  68652077  6F726C64  2E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C000008e0000002a00000031', 103);
DEFINE CLOB @'C00000620000002a0000004c' LENGTH 76 VALUE
   54686520  73746F72  79206F66  20612067  65726D61  6E20746F  776E2063  61756768
   7420696E  20746865  20677269  70206F66  20612063  68696C64  206D6F6C  65737465
   722F6D75  72646572  65722E20;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000620000002a0000004c', 113);
DEFINE CLOB @'C00000890000002a0000001a' LENGTH 26 VALUE
   41207363  61727920  6672656E  63682063  756C7420  6D6F7669  652E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000890000002a0000001a', 119);
DEFINE CLOB @'C00000630000002a000000a2' LENGTH 162 VALUE
   54686520  736D616C  6C20746F  776E206F  66204869  636B6F72  792C2049  6E646961
   6E612062  72696E67  7320696E  206F7574  73696465  7220436F  61636820  4E6F726D
   616E2044  616C6520  746F206C  65616420  74686569  72206F75  746D6174  63686564
   20686967  68207363  686F6F6C  20626173  6B657462  616C6C20  7465616D  20616761
   696E7374  20746865  20726573  74206F66  20746865  20737461  74652773  20626573
   742E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000630000002a000000a2', 125);
DEFINE CLOB @'C000005a0000002a0000000f' LENGTH 15 VALUE
   56657279  20657863  6974696E  67210A;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C000005a0000002a0000000f', 102);
DEFINE CLOB @'C00000640000002a000000d0' LENGTH 208 VALUE
   54686520  66696C6D  20666F6C  6C6F7773  2074776F  20796F75  6E672020  626C6163
   6B206261  736B6574  62616C6C  20706C61  79657273  20696E20  43686963  61676F20
   61732074  68657920  6C656176  65206772  616D6D61  72207363  686F6F6C  20616E64
   20656E74  65722068  69676820  7363686F  6F6C2077  69746820  68696768  20657870
   65637461  74696F6E  7320666F  72207468  65697220  66757475  72657320  696E2074
   68652077  6F726C64  206F6620  636F6C6C  65676520  616E6420  70726F66  65737369
   6F6E616C  20626173  6B657462  616C6C2E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000640000002a000000d0', 126);
DEFINE CLOB @'C000008a0000002a000001f5' LENGTH 501 VALUE
   4D696464  6C652D61  67656420  6E6F7665  6C697374  2048756D  62657274  2048756D
   62657274  2072656E  74732061  20726F6F  6D20696E  20436861  726C6F74  74652048
   617A6527  7320686F  75736520  61667465  72206865  2066616C  6C732070  61737369
   6F6E6174  656C7920  696E206C  6F766520  77697468  20686572  20646175  67687465
   72204C6F  6C697461  2E205468  65726520  61726520  74687265  6520736C  69676874
   2070726F  626C656D  732C2074  686F7567  68202D20  6F6E652C  20436861  726C6F74
   74652069  73206D61  646C7920  696E206C  6F766520  77697468  2068696D  2028756E
   72657175  69746564  2C206E65  65646C65  73732074  6F207361  79293B20  74776F2C
   204C6F6C  69746120  6973206F  6E6C7920  666F7572  7465656E  3B207468  7265652C
   20746865  72652773  20612076  65727920  70656375  6C696172  20666967  75726520
   62792074  6865206E  616D6520  6F662043  6C617265  20517569  6C747920  77686F20
   6B656570  7320706F  7070696E  67207570  20696E20  74686520  6D6F7374  20756E65
   78706563  74656420  706C6163  65732028  616E6420  73706F72  74696E67  20657175
   616C6C79  20756E65  78706563  74656420  61636365  6E747329  2C207768  6F207365
   656D7320  746F2068  61766520  61207369  6D696C61  726C7920  756E6865  616C7468
   7920696E  74657265  73742069  6E204C6F  6C697461  2E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C000008a0000002a000001f5', 114);
DEFINE CLOB @'C00000650000002a00000043' LENGTH 67 VALUE
   41204368  72697374  6D617320  61742053  4F532041  6D697469  C3A92028  61206672
   656E6368  20227375  69636964  6520686F  746C696E  65222065  71756976  616C656E
   74290A;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000650000002a00000043', 120);
DEFINE CLOB @'C000005b0000002a00000106' LENGTH 262 VALUE
   426F756E  74792068  756E7465  72204A61  636B2057  616C7368  20736574  73206F75
   7420746F  20627269  6E672062  61696C20  6A756D70  6572204A  6F6E6174  68616E20
   4D617264  756B6173  20626163  6B20746F  204C6F73  20416E67  656C6573  20666F72
   20747269  616C2E20  42757420  61667465  72206669  6E64696E  67206869  6D2C2057
   616C7368  20646973  636F7665  72732074  68617420  74686520  2244756B  65222077
   61732061  206D6166  69612061  63636F75  6E74616E  74207768  6F20646F  6E617465
   64206D69  6C6C696F  6E73206F  6620646F  6C6C6172  7320746F  20636861  72697469
   65732061  66746572  20656D62  657A7A6C  696E6720  69742066  726F6D20  74686520
   6D616669  612E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C000005b0000002a00000106', 131);
DEFINE CLOB @'C00000660000002a000000d9' LENGTH 217 VALUE
   57696C6C  20477261  68616D20  69732062  726F7567  6874206F  7574206F  66207265
   74697265  6D656E74  20746F20  70757273  75652061  6E20656C  75736976  65207365
   7269616C  206B696C  6C65722E  20496E20  6F726465  7220746F  2066696E  64207468
   65206B69  6C6C6572  2C204772  6168616D  206D7573  74207265  7475726E  20746F20
   44722E20  48616E6E  6962616C  204C6563  746F722C  20746865  20736572  69616C20
   6B696C6C  65722068  65206361  70747572  65642061  66746572  20616C6D  6F737420
   6C6F7369  6E672068  6973206D  696E6420  616E6420  6C696665  2E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000660000002a000000d9', 130);
DEFINE CLOB @'C000005f0000002a00000167' LENGTH 359 VALUE
   44722E20  52696368  61726420  57616C6B  65722061  6E642068  69732077  69766520
   61727269  76652069  6E205061  72697320  666F7220  6120776F  726B696E  67207661
   63617469  6F6E2E20  42757420  4D72732E  2057616C  6B657220  64697361  70706561
   72732061  6C6D6F73  7420696D  6D656469  6174656C  792C206C  65617669  6E672044
   722E2057  616C6B65  72206465  73706172  6174656C  79207472  79696E67  20746F20
   74726163  6B206865  7220646F  776E2077  6974686F  75742061  6E792066  72656E63
   68206C61  6E677561  67652073  6B696C6C  73206F72  206D7563  68206865  6C702066
   726F6D20  74686520  6672656E  63682070  6F6C6963  65206F72  20746865  20555320
   656D6261  7373792E  20457665  6E747561  6C6C7920  68652066  696E6473  204D6963
   68656C6C  652C2074  68652073  6D756767  6C657220  77686F20  616C736F  206D7573
   74206469  73636F76  65722077  686F2069  73206265  68696E64  20746865  20616264
   75637469  6F6E2E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C000005f0000002a00000167', 128);
DEFINE CLOB @'C000008f0000002a000000fd' LENGTH 253 VALUE
   436F706F  6C612773  206D6F76  69652069  73206261  73656420  6F6E2043  6F6E7261
   64277320  48656172  74206F66  20446172  6B6E6573  73207365  7420696E  20566965
   746E616D  20616E64  2043616D  626F6469  612E2043  61707461  696E2042  656E6A61
   6D696E20  57696C6C  61726420  69732073  6574206F  6E206120  73656372  6574206D
   69737369  6F6E2074  6F202274  65726D69  6E617465  22207468  65207265  6E656761
   64652043  6F6C6F6E  656C204B  7572747A  2077686F  20697320  77616769  6E672061
   6E206566  66656374  69766520  62757420  696E6465  70656E64  656E7420  77617220
   61676169  6E737420  74686520  4E6F7274  68205669  65746E65  6D657365  2E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C000008f0000002a000000fd', 135);
DEFINE CLOB @'C00000670000002a000000ab' LENGTH 171 VALUE
   42726964  67657420  47726567  6F727920  73746561  6C732064  72756720  6D6F6E65
   79206672  6F6D2068  65722068  75736261  6E642061  6E642074  72696573  20746F20
   68696420  696E2075  70737461  7465204E  65772059  6F726B2E  20576865  6E206865
   72206C61  77796572  2074656C  6C732068  65722074  6F20626C  656E6420  696E2061
   6E642067  65742061  20626F79  66726965  6E642C20  7468696E  67732067  65742069
   6E746572  65737469  6E672E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000670000002a000000ab', 132);
DEFINE CLOB @'C00000680000002a000000e2' LENGTH 226 VALUE
   5768656E  204D6963  6861656C  20617272  69766573  20696E20  74686520  746F776E
   206F6620  52656420  526F636B  206F7574  206F6620  6D6F6E65  7920616E  6420646F
   776E206F  6E206869  73206C75  636B2C20  5761796E  65206D69  7374616B  65732068
   696D2066  6F722074  68652068  6974206D  616E2068  65206869  72656420  746F206B
   696C6C20  68697320  77696665  2E204275  7420736F  6F6E204D  69636861  656C206D
   65657473  20576179  6E652773  20776966  6520616E  64207468  65207265  616C2068
   6974206D  616E2061  72726976  65732061  6E642074  68696E67  73206865  61742075
   702E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000680000002a000000e2', 133);
DEFINE CLOB @'C00000690000002a00000085' LENGTH 133 VALUE
   54686520  6D6F7669  65207472  61636B73  20746865  206C6976  6573206F  66203520
   66726965  6E647320  77686F20  72656775  6C617279  206D6565  74206174  20746865
   2044696E  65722074  6F207368  61726520  73746F72  69657320  616E6420  66696775
   7265206F  75742077  68657265  20746865  6972206C  69766573  20617265  20686561
   64696E67  2E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000690000002a00000085', 140);
DEFINE CLOB @'C000006a0000002a0000011f' LENGTH 287 VALUE
   41667465  72206669  6E697368  696E6720  68697320  73656E74  656E6365  20666F72
   2061726D  65642072  6F626265  72792C20  4A616B65  20697320  72656C65  61736520
   66726F6D  20707269  736F6E20  6F6E6C79  20746F20  64697363  6F766572  20746861
   74207468  6520636F  756E7479  20697320  676F696E  6720746F  20636C6F  73652074
   68652063  6174686F  6C696320  7363686F  6F6C2068  6520616E  6420456C  776F6F64
   20617474  656E6465  64206173  20636869  6C647265  6E2E2042  6F746820  73657420
   6F757420  746F2072  65637265  61746520  22746865  2062616E  64222069  6E20616E
   20617474  656D7074  20746F20  72616973  6520656E  6F756768  206D6F6E  65792074
   6F207061  79207468  65207461  78657320  666F7220  74686520  7363686F  6F6C2E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C000006a0000002a0000011f', 143);
DEFINE CLOB @'C000006b0000002a000000a1' LENGTH 161 VALUE
   4D696368  61656C20  4D6F6F72  65207472  61636B73  20746865  2064656D  69736520
   6F662068  69732068  6F6D6520  746F776E  206F6620  466C696E  74204D69  63686967
   616E2E20  48697320  756C7469  6D617465  20676F61  6C206973  20746F20  64697265
   63742068  69732071  75657374  696F6E73  20746F20  526F6765  7220536D  6974682C
   20746865  20707265  73696465  6E74206F  66204765  6E657261  6C204D6F  746F7273
   2E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C000006b0000002a000000a1', 148);
DEFINE CLOB @'C000006c0000002a000000fd' LENGTH 253 VALUE
   4A616B65  20476974  74657320  69732068  69726564  20666F72  20746865  20617070
   6172656E  746C7920  73696D70  6C652074  61736B20  6F662064  6F63756D  656E7469
   6E672074  68652065  78747261  2D6D6172  6974616C  20616374  69766974  69657320
   6F662068  65722068  75736261  6E642E20  42757420  61667465  7220656E  636F756E
   74657269  6E672061  20666577  20657863  65707469  6F6E616C  6C792075  6E68656C
   7066756C  20616E64  20646F77  6E207269  67687420  76696F6C  656E7420  70656F70
   6C652C20  47697474  65732073  74617274  7320746F  20756E72  6176656C  2061206D
   617A6520  6F662063  6F727275  7074696F  6E20616E  64206465  63656974  2E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C000006c0000002a000000fd', 150);
DEFINE CLOB @'C000006d0000002a00000113' LENGTH 275 VALUE
   4465636B  61726420  69732063  68617267  65642077  69746820  74726163  6B696E67
   20646F77  6E20616E  64206465  7374726F  79696E67  20612067  726F7570  206F6620
   65736361  70656420  7265706C  6963616E  74732E20  4F662063  6F757273  65207468
   65736520  7265706C  6963616E  74732061  72652074  6865206C  61746573  74206D6F
   64656C73  20746861  74206172  65206765  7474696E  6720616C  6C207468  65206D6F
   72652068  756D616E  2C206D61  6B696E67  20446563  6B617264  2773206A  6F622061
   6C6C2074  68652074  6F756768  65722061  6E642072  61697365  73207175  65737469
   6F6E7320  61626F75  74207468  6520726F  6C65206F  66207468  65736520  6D616368
   696E6573  2E205665  72792053  63692D46  692E0A;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C000006d0000002a00000113', 146);
DEFINE CLOB @'C000006e0000002a0000008f' LENGTH 143 VALUE
   42617365  64206F6E  20746865  20747275  65207374  6F727920  6F662048  656E7279
   2048696C  6C2E2054  68652066  696C6D20  74726163  6B732074  68652072  69736520
   6F662048  696C6C2C  204A616D  65732043  6F6E7761  792C2061  6E642054  6F6D6D79
   20446556  69746F20  61732074  68657920  776F726B  20746865  69722077  61792075
   7020696E  20746865  206D6166  69612E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C000006e0000002a0000008f', 142);
DEFINE CLOB @'C000006f0000002a00000140' LENGTH 320 VALUE
   54686520  72756C69  6E672063  6C697175  65206174  20576573  74657262  65726720
   48696768  20697320  72756E6E  696E6720  616C6F6E  6720736D  6F6F7468  6C792075
   6E74696C  206E6577  20636F6D  6572204A  2E442E20  28666F72  204A616D  65732044
   65616E3F  29206172  72697665  7320616E  6420636F  6E76696E  63657320  5665726F
   6E696361  20746861  7420736F  6D65206D  69736368  69656620  776F756C  64206D61
   6B652074  68696E67  73206D75  6368206D  6F726520  696E7465  72657374  696E672E
   20576865  6E205665  726F6E69  63612064  6973636F  76657273  20226D69  73636869
   65662220  696E766F  6C766573  2062756D  70696E67  206F6666  206F7468  65722073
   74756465  6E747320  616E6420  73746167  696E6720  656C6162  6F726174  65207375
   69636964  65206672  616D652D  75707320  7468696E  67732067  65742064  61726B2E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C000006f0000002a00000140', 147);
DEFINE CLOB @'C00000700000002a000000d9' LENGTH 217 VALUE
   49727769  6E20466C  65746368  65722069  7320616E  20696E76  65737469  67617469
   76652072  65706F72  74657220  73656172  6368696E  6720666F  72207468  65207374
   6F727920  62656869  6E642074  68652064  72756720  74726164  65206F6E  20746865
   20626561  63682E20  42757420  68652073  6F6F6E20  66696E64  73206869  6D73656C
   66206472  61776E20  696E746F  20657870  6F73696E  67206120  73657061  72617465
   20636F6E  2C207468  61742073  68617265  7320736F  6D652063  7572696F  75732070
   6C617965  72732061  73207468  65206472  75672074  72616465  2E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000700000002a000000d9', 149);
DEFINE CLOB @'C00000710000002a00000133' LENGTH 307 VALUE
   526F7567  686C7920  62617365  64206F6E  20746865  2073746F  72792062  6568696E
   64207468  65203139  3838204A  616D616D  6963616E  20626F62  736C6564  20746561
   6D2E2041  66746572  20626569  6E672064  656E6965  6420706C  61636573  206F6E20
   74686520  73756D6D  6572206F  6C796D70  69632074  65616D20  61732061  20737072
   696E7465  722C204C  656F6E20  72656372  75697473  20746872  6565206F  74686572
   7320616E  64207468  65207265  6C756374  616E7420  636F6163  68204972  7620746F
   206A6F69  6E206869  6D206F6E  20746865  20746561  6D2E2041  6C6F6E67  20746865
   20776179  20746865  20746561  6D20656E  636F756E  74657273  206D616E  7920736B
   65707469  63732061  6E642064  6973636F  76657273  20746865  20636F6C  6F726564
   20706173  74206F66  20746865  20636F61  63682E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000710000002a00000133', 145);
DEFINE CLOB @'C00000720000002a00000067' LENGTH 103 VALUE
   5768656E  204D6F6D  20616E64  20446164  20686176  6520746F  206C6561  76652074
   6F776E2C  20626163  68656C6F  72206174  206C6172  67652C20  556E636C  65204275
   636B2C20  636F6D65  7320746F  2074616B  65206361  7265206F  66207468  65206368
   696C6472  656E2E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000720000002a00000067', 144);
DEFINE CLOB @'C00000730000002a00000049' LENGTH 73 VALUE
   54686520  454F4620  70726F64  75637420  61747465  6D707473  20746F20  676F2077
   68657265  206E6F20  64617461  62617365  2070726F  64756374  20686173  20676F6E
   65206265  666F7265  21;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000730000002a00000049', 205);
DEFINE CLOB @'C00000740000002a0000005c' LENGTH 92 VALUE
   416E2065  7069632D  7363616C  6520576F  726C6420  57617220  49492066  696C6D20
   61626F75  74206120  70726976  696C6567  65642062  6F792063  61707475  72656420
   62792074  6865204A  6170616E  65736520  696E2053  68616E67  6861692E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000740000002a0000005c', 155);
DEFINE CLOB @'C00000750000002a00000103' LENGTH 259 VALUE
   4C6F6F73  656C7920  62617365  64206F6E  20746865  20747275  65207374  6F727920
   6F662045  6C6C696F  74204E65  73732E0A  46727573  74726174  65642062  79207468
   65207065  6E657472  6174696F  6E206F66  20636F72  72757074  696F6E20  696E2043
   68696361  676F2C20  4E657373  20707574  7320746F  67657468  65722061  20736D61
   6C6C2069  6E646570  656E6465  6E742054  72656173  75727920  6F666669  63657273
   20646564  69636174  65642074  6F207468  65206465  73747275  6374696F  6E206F66
   20746865  20436869  6361676F  204D6F62  2E0A476F  6F642073  63656E65  20737472
   65737369  6E672074  68652069  6D706F72  74616E63  65206F66  20746561  6D20776F
   726B2E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000750000002a00000103', 151);
DEFINE CLOB @'C00000760000002a000000ab' LENGTH 171 VALUE
   416E2069  6465616C  69737469  6320796F  756E6720  70726965  7374206D  75737420
   6465616C  20776974  68207468  6520706F  76657274  79206F66  20686973  206E6577
   20706172  6973682C  20746865  206C6178  20617474  69747564  65206F66  20686973
   2066656C  6C6F7720  70617374  6F722C20  6120796F  756E6720  6769726C  20626569
   6E672061  62757365  64206279  20686572  20666174  6865722C  20616E64  20686973
   206F776E  20736861  6D652E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000760000002a000000ab', 153);
DEFINE CLOB @'C00000770000002a00000131' LENGTH 305 VALUE
   546F7973  20636F6D  6520746F  206C6966  65207768  656E2074  68652068  756D616E
   73206172  65206177  61792E20  20436C61  73736963  20627564  64792066  6C69636B
   20696E20  77686963  68206120  73706163  656D616E  20746F79  20284275  7A7A204C
   69676874  79656172  29206172  72697665  73206174  20612062  69727468  64617920
   70617274  7920616E  64207468  72656174  656E7320  746F2064  6973706C  61636520
   74686520  636F7762  6F792028  576F6F64  79292061  73207468  65206368  696C6427
   73206661  766F7269  74652074  6F792E20  20546865  2074776F  20726976  616C7320
   67657420  6C6F7374  20616E64  20657665  6E747561  6C6C7920  6265636F  6D652066
   7269656E  64732C20  776F726B  696E6720  746F6765  74686572  20746F20  66696E64
   20746865  69722077  61792068  6F6D652E  0A;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000770000002a00000131', 158);
DEFINE CLOB @'C00000780000002a00000028' LENGTH 40 VALUE
   42617365  64206F6E  20746865  206E6F76  656C2062  79204C6F  75697361  204D6179
   20416C63  6F74742E;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000780000002a00000028', 154);
DEFINE CLOB @'C00000790000002a000000f4' LENGTH 244 VALUE
   48617272  79204275  726E7320  616E6420  53616C6C  7920416C  62726967  68742067
   72616475  616C6C79  20626563  6F6D6520  66726965  6E647320  6F766572  20746865
   20636F75  72736520  6F662073  65766572  616C2079  65617273  20616E64  20666169
   6C656420  70617274  6E657273  2E204576  656E7475  616C6C79  20746865  20736C65
   65702074  6F676574  68657220  616E6420  77726563  6B732074  68652066  7269656E
   64736869  702E2042  75742065  76656E74  75616C6C  79207468  65792067  65742062
   61636B20  746F6765  74686572  20616E64  20657665  72796F6E  65206C69  76657320
   68617070  696C7920  65766572  20616674  65722E0A;
INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (@'C00000790000002a000000f4', 152);
#INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 2);
#INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 3);
#INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 4);
#INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 5);
#INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 7);
#INSERT INTO "Plot_Summary" ("Summary", "Movie_Id") VALUES (NULL, 8);
COMMIT;
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1981-12-27 00:00:00', NULL, 7, NULL, 'Raiders of the Lost Ark', 'Action', 'G', 102, 14400000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1931-12-28 12:00:00', NULL, 11, NULL, 'M', 'Film-noir', 'G', 113, 200000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1955-12-28 12:00:00', NULL, 9, NULL, 'Casablanca', 'Drama', 'G', 111, 11200000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1962-12-28 12:00:00', NULL, 7, NULL, 'Lolita', 'Drama', 'PG', 114, 400000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1967-12-28 12:00:00', NULL, 12, NULL, 'Hombre', 'Western', 'PG', 115, 300000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1954-01-02 12:00:00', NULL, 13, NULL, 'Les Diaboliques', 'Thriller', NULL, 119, 200000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1982-01-02 12:00:00', NULL, NULL, NULL, 'Le pre nol est une ordure', 'Comedy', NULL, 120, NULL);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1991-01-02 12:00:00', NULL, NULL, NULL, 'Dlicatessen', 'Surreal', 'R', 121, NULL);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1991-01-03 12:00:00', NULL, 7, NULL, 'Bis ans Ende der Welt [Until the End of the World]', 'Surreal', NULL, 124, 500000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1986-01-03 12:00:00', NULL, 14, NULL, 'Hoosiers', 'Drama', 'PG', 125, 1200000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1994-01-03 12:00:00', NULL, 15, NULL, 'Hoop Dreams', 'Documentary', 'PG-13', 126, 600000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1990-01-03 12:00:00', NULL, NULL, NULL, 'La discrte', 'Romantic', NULL, 127, NULL);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1988-01-03 12:00:00', NULL, 43, NULL, 'Frantic', 'Thriller', 'R', 128, 700000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1986-01-03 12:00:00', NULL, 8, NULL, 'Manhunter', 'Thriller', 'R', 130, 900000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1988-01-03 12:00:00', NULL, 16, NULL, 'Midnight Run', 'Action', 'R', 131, 1000000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1994-01-03 12:00:00', NULL, 18, NULL, 'The Last Seduction', 'Film-noir', 'R', 132, 800000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1992-01-03 12:00:00', NULL, 19, NULL, 'Red Rock West', 'Film-noir', 'R', 133, 700000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1979-01-03 12:00:00', NULL, 20, NULL, 'Apocalypse Now', 'Drama', 'R', 135, 1334000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1988-01-03 12:00:00', NULL, 12, NULL, 'Le grand bleu', 'Surreal', NULL, 136, 800000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1985-01-03 12:00:00', NULL, 21, NULL, 'Subway', 'Cult', 'R', 137, 300000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1980-01-03 12:00:00', NULL, 22, NULL, 'Diva', 'Drama', 'R', 138, 1000000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1982-01-03 12:00:00', NULL, 8, NULL, 'Diner', 'Drama', 'R', 140, 200000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1990-01-03 12:00:00', NULL, 21, NULL, 'Nikita [La femme nikita]', 'Thriller', 'R', 141, 900000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1989-01-03 12:00:00', NULL, 16, NULL, 'Uncle Buck', 'Comedy', 'PG', 144, 1000000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1993-01-03 12:00:00', NULL, 23, NULL, 'Cool Runnings', 'Comedy', 'PG', 145, 200000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1989-01-03 12:00:00', NULL, 24, NULL, 'Heathers', 'Film-noir', 'R', 147, 4400000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1989-01-03 12:00:00', NULL, 9, NULL, 'Roger & Me', 'Documentary', 'R', 148, 600000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1985-01-03 12:00:00', NULL, 16, NULL, 'Fletch', 'Comedy', 'PG', 149, 300000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1974-01-03 12:00:00', NULL, 7, NULL, 'Chinatown', 'Detective', 'R', 150, 500000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1987-01-03 12:00:00', NULL, 7, NULL, 'The Untouchables', 'Action', 'R', 151, 1390000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1989-01-03 12:00:00', NULL, 11, NULL, 'When Harry met Sally', 'Romantic Comedy', 'R', 152, 26400000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1995-04-14 00:00:00', NULL, 25, NULL, 'Priest', 'Drama', 'R', 153, 4310000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (NULL, NULL, 11, NULL, 'Little Women', 'Drama', 'G', 154, 600000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1987-01-04 12:00:00', NULL, 9, NULL, 'Empire of the Sun', 'Drama', 'PG', 155, 800000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1995-11-22 00:00:00', NULL, 23, NULL, 'Toy Story', 'Animated', 'G', 158, 500000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1979-10-25 00:00:00', NULL, 12, NULL, 'Alien', 'Horror', 'R', 159, 11200000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1985-04-24 00:00:00', NULL, 26, NULL, 'The Terminator', 'Action', 'R', 160, 300000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1982-11-11 00:00:00', NULL, 11, NULL, 'Tootsie', 'Comedy', 'R', 162, 600000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1994-11-11 00:00:00', NULL, 25, NULL, 'Pulp Fiction', 'Film-noir', 'R', 164, 47700000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1993-11-11 00:00:00', NULL, 28, NULL, 'The Piano', 'Drama', 'R', 165, 700000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1993-11-11 00:00:00', NULL, 16, NULL, 'Jurassic Park', 'Action', 'PG-13', 166, 400000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1993-11-11 00:00:00', NULL, 16, NULL, 'Schindler''s List', 'Drama', 'R', 169, 900000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1978-11-11 00:00:00', NULL, 16, NULL, 'National Lampoon''s Animal House', 'Comedy', 'R', 170, 800000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1981-11-11 00:00:00', NULL, 29, NULL, 'My Dinner With Andre', 'Drama', 'PG', 171, 500000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1986-11-11 00:00:00', NULL, 30, NULL, 'My Beautiful Laundrette', 'Drama', 'R', 172, 500000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1983-11-11 00:00:00', NULL, 31, NULL, 'Entre Nous', 'Drama', 'PG', 174, 700000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1986-11-11 00:00:00', NULL, 43, NULL, 'Stand By Me', 'Drama', 'R', 176, 200000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1991-11-11 00:00:00', NULL, 32, NULL, 'My Own Private Idaho', 'Drama', 'R', 177, 8800000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1986-11-11 00:00:00', NULL, 33, NULL, 'Blue Velvet', 'Drama', 'R', 178, 300000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1974-11-11 00:00:00', NULL, 34, NULL, 'Amarcord', 'Comedy', 'R', 179, 3213000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1990-11-11 00:00:00', NULL, 35, NULL, 'Total Recall', 'Action', 'R', 180, 300000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1973-11-11 00:00:00', NULL, 13, NULL, 'Cries and Whispers', 'Drama', 'R', 183, 100000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1985-11-11 00:00:00', NULL, 36, NULL, 'Desert Hearts', 'Drama', 'R', 184, 200000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1986-11-11 00:00:00', NULL, 37, NULL, 'She''s Gotta Have It', 'Comedy', 'R', 185, 600000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1989-11-11 00:00:00', NULL, 37, NULL, 'Do the Right Thing', 'Comedy', 'R', 186, 700000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1991-11-11 00:00:00', NULL, 8, NULL, 'Thelma & Louise', 'Drama', 'R', 187, 800000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1971-11-11 00:00:00', NULL, 9, NULL, 'Klute', 'Drama', 'R', 189, 500000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1976-11-11 00:00:00', NULL, 43, NULL, 'Eraserhead', 'Surreal', NULL, 190, 400000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1987-11-11 00:00:00', NULL, 42, NULL, 'Prick Up Your Ears', 'Drama', 'R', 191, 700000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1976-11-11 00:00:00', NULL, 11, NULL, 'Taxi Driver', 'Drama', 'R', 193, 100000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1974-11-11 00:00:00', NULL, 12, NULL, 'Young Frankenstein', 'Comedy', 'PG', 194, 900000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1949-11-11 00:00:00', NULL, 41, NULL, 'Third Man, The', 'Thriller', 'PG', 196, 1000000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1946-11-11 00:00:00', NULL, 40, NULL, 'Notorious', 'Thriller', NULL, 197, 900000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1941-11-11 00:00:00', NULL, 40, NULL, 'Citizen Kane', 'Drama', NULL, 198, 100000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1969-11-11 00:00:00', NULL, 7, NULL, 'Once Upon a Time in the West', 'Western', NULL, 200, 800000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1980-01-05 12:00:00', NULL, 27, NULL, 'Bad Timing', 'Drama', 'R', 202, 1000000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1958-11-11 00:00:00', NULL, 50, NULL, 'Plan 9 from Outer Space', 'Sci-Fi', NULL, 203, 200000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1977-12-29 12:00:00', NULL, 12, NULL, 'Star Wars', 'Action', 'PG', 101, 600000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1982-01-03 12:00:00', NULL, 9, NULL, 'Blade Runner', 'Sci-Fi', 'R', 146, 400000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1983-12-29 12:00:00', NULL, 41, NULL, 'Strange Brew', 'Comedy', 'PG', 118, 9900000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1972-12-28 12:00:00', NULL, 7, NULL, 'The Godfather', 'Action', 'R', 103, 300000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1990-11-11 00:00:00', NULL, 39, NULL, 'The Grifters', 'Drama', 'R', 182, 100000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1969-11-11 00:00:00', NULL, 12, NULL, 'The Prime of Miss Jean Brodie', 'Drama', 'PG', 192, 500000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1940-11-11 00:00:00', NULL, 8, NULL, 'The Philadelphia Story', 'Comedy', NULL, 199, 1000000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1988-10-13 00:00:00', NULL, 20, NULL, 'The Princess Bride', 'Comedy', 'PG', 157, 300000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1980-01-03 12:00:00', NULL, 16, NULL, 'The Blues Brothers', 'Musical', 'R', 143, 700000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1992-11-11 00:00:00', NULL, 38, NULL, 'The Player', 'Comedy', 'R', 188, 500000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1983-11-11 00:00:00', NULL, 8, NULL, 'The Year of Living Dangerously', 'Thriller', 'PG', 181, 800000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1971-11-11 00:00:00', NULL, 11, NULL, 'The Last Picture Show', 'Drama', 'R', 175, 400000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1996-01-24 12:00:00', NULL, 50, NULL, ' EOF Next Generation', 'Surreal', 'G', 205, 600000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1986-01-03 00:00:00', NULL, 51, NULL, '37.2 le Matin [Betty Blues]', 'Drama', 'R', 129, 200000);
INSERT INTO "Movie" ("Date_Released", "Trailer_Name", "Studio_Id", "Poster_Name", "Title", "Category", "Rated", "Movie_Id", "Revenue") VALUES (TIMESTAMP '1990-01-03 12:00:00', NULL, 9, NULL, 'GoodFellas', 'Action', 'R', 142, 2021000);
COMMIT;
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (87, 'Ford', 'Harrison');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (88, 'Lucas', 'George');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (86, 'Hammil', 'Mark');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (93, 'Brando', 'Marlon');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (92, 'Keaton', 'Dianne');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (91, 'Copola', 'Francis Ford');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (90, 'Pacino', 'Al');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (100, 'Bogart', 'Humphrey');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (99, 'Curtiz', 'Michael');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (101, 'Bergman', 'Ingrid');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (102, 'Greenstreet', 'Sidney');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (103, 'Lorre', 'Peter');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (107, 'Lang', 'Fritz');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (111, 'Lyon', 'Sue');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (113, 'Sellers', 'Peter');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (112, 'Winters', 'Shelley');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (110, 'Mason', 'James');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (109, 'Kubrick', 'Stanley');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (114, 'Ritt', 'Martin');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (115, 'Newman', 'Paul');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (124, 'Signoret', 'Simone');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (117, 'Moranis', 'Rick');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (118, 'Thomas', 'Dave');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (119, 'Von Sydow', 'Max');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (120, 'Fisher', 'Carrie');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (121, 'Allen', 'Karen');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (125, 'Clouzot', 'Vera');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (127, 'Clouzot', 'Henri-Georges');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (126, 'Serrault', 'Michel');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (123, 'Meurisse', 'Paul');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (122, 'Vanel', 'Charles');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (138, 'Poir', 'Jean-Marie');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (137, ' ', 'Anmone');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (139, 'Balasko', 'Josianne');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (141, 'Clavier', 'Christian');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (143, 'Jugnot', 'Grard');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (144, 'Chazel', 'Marie-Anne');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (147, 'Magnin', 'Claire');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (146, 'Lamotte', 'Martin');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (145, 'Franois', 'Jacques');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (142, 'Moynot', 'Bruno');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (140, 'Lhermitte', 'Thierry');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (158, 'Pinon', 'Dominique');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (154, 'Laguna', 'Silvie');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (152, 'Saunders', 'Justine');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (151, 'Caro', 'Marc');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (157, 'Dreyfus', 'Jean-Claude');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (153, 'Perrier', 'Jean-Franois');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (155, 'Dougnac', 'Marie-Laure');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (156, 'Jeunet', 'Jean-Pierre');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (150, 'Holgado', 'Ticky');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (149, 'Pisani', 'Anne-Marie');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (148, 'Viard', 'Karin');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (163, 'Hopper', 'Dennis');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (164, 'Anspaugh', 'David');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (162, 'Hershey', 'Barbara');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (161, 'Hackman', 'Gene');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (182, 'Dommartin', 'Solveig');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (189, 'Hurt', 'William');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (201, 'Turrin', 'Enzo');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (197, 'Falcone', 'Pietro');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (203, 'Berk', 'Ernest');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (202, 'Takenaka', 'Naoto');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (204, 'McMahon', 'Chalie');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (199, 'Miyake', 'Kuniko');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (200, 'Moreau', 'Jeanne');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (198, 'Willoughby', 'Bart');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (194, 'Winterberg', 'Detlef');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (196, 'Smirnova', 'Elena');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (183, 'Ogata', 'Yugi');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (193, 'Jinzan', 'Zhang');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (195, 'Mitchell', 'Eddy');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (186, 'Leith', 'Susan');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (192, 'Ortega', 'Chick');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (187, 'Osterlein', 'Christine');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (185, 'Livingston', 'Paul');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (188, 'Little', 'Jimmy');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (179, 'Vogler', 'Ruediger');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (190, 'Doria', 'Diogo');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (175, 'Jason', 'Alec');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (178, 'Lynch', 'Alfred');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (212, 'Luchini', 'Fabrice');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (184, 'Gulpilil', 'David');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (171, 'Fujitani', 'Miwako');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (173, 'Rodriguez', 'Amalia');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (176, 'Belling', 'Kylie');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (181, 'Dumay', 'Jean-Charles');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (180, 'Dingo', 'Ernie');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (170, 'Walsh', 'Fred');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (177, 'Lutz', 'Adelle');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (169, 'Graham', 'Lauren');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (166, 'Kanbe', 'Hiroshi');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (174, 'Chiles', 'Lois');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (172, 'Roberts', 'Rhoda');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (168, 'Garfield', 'Allen');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (167, 'Neil', 'Sam');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (165, 'Wenders', 'Wim');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (208, 'Thomas', 'Isiah');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (207, 'James', 'Steve');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (206, 'Gates', 'William');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (205, 'Agee', 'Arthur');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (210, 'Vincent', 'Christian');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (213, 'Henry', 'Judith');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (211, 'Garrel', 'Maurice');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (209, 'Bunel', 'Marie');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (215, 'Seigner', 'Emmanuelle');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (216, 'Polanski', 'Roman');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (214, 'Buckley', 'Betty');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (217, 'Anglade', 'Jean-Hugues');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (218, 'Beineix', 'Jean-Jacques');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (220, 'Dalle', 'Batrice');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (223, 'Darmont', 'Grard');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (222, 'De Haviland', 'Consuelo');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (221, 'Clari', 'Clmentine');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (219, 'Mathou', 'Jacques');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (227, 'Petersen', 'William');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (228, 'Mann', 'Michael');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (226, 'Farina', 'Dennis');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (225, 'Cox', 'Brian');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (224, 'Butler', 'Dan');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (232, 'Brest', 'Martin');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (233, 'Kotto', 'Yaphet');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (234, 'Grodin', 'Charles');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (231, 'Ashton', 'John');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (230, 'De Niro', 'Robert');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (229, 'Pantoliano', 'Joe');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (238, 'Berg', 'Peter');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (236, 'Pullman', 'Bill');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (237, 'Dahl', 'John');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (235, 'Fiorentino', 'Linda');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (240, 'Cage', 'Nicolas');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (241, 'Boyle', 'Lara Flynn');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (239, 'Walsh', 'J.T.');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (246, 'Duvall', 'Robert');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (247, 'Sheen', 'Martin');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (245, 'Fishburne', 'Laurence');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (249, 'Barr', 'Jean-Marc');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (250, 'Reno', 'Jean');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (252, 'Arquette', 'Rosanna');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (251, 'Besson', 'Luc');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (248, 'Fontana', 'Patrick');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (259, 'Lecas', 'Jean-Claude');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (258, 'Blanche', 'Jimmy');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (257, 'Lambert', 'Christophe');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (255, 'Galabru', 'Michel');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (256, 'Adjani', 'Isabelle');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (254, 'Bohringer', 'Richard');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (253, 'Bacri', 'Jean-Pierre');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (260, 'Fernandez', 'Wilhelmenia');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (280, 'Stern', 'Daniel');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (279, 'Guttenberg', 'Steve');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (277, 'Levinson', 'Barry');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (276, 'Reiser', 'Paul');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (278, 'Daly', 'Timothy');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (275, 'Bacon', 'Kevin');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (273, 'Tucker', 'Michael');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (272, 'Dowling', 'Kathyrn');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (271, 'Barkin', 'Ellen');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (274, 'Rourke', 'Mickey');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (282, 'Cathire', 'Alain');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (284, 'Karyo', 'Tchky');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (283, 'Parillaud', 'Anne');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (281, 'Duret', 'Marc');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (288, 'Pesci', 'Joe');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (290, 'Bracco', 'Lorraine');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (287, 'Liotta', 'Ray');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (289, 'Sorvino', 'Paul');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (285, 'Scorsese', 'Martin');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (286, 'Jackson', 'Samuel L.');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (302, 'Lawson', 'Twiggy');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (301, 'Calloway', 'Cab');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (299, 'Charles', 'Ray');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (300, 'Landis', 'John');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (298, 'Aykroyd', 'Dan');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (297, 'Belushi', 'John');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (296, 'Reubens', 'Paul');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (295, 'Candy', 'John');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (293, 'Kahn', 'Chaka');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (292, 'Brown', 'James');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (291, 'Franklin', 'Aretha');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (308, 'Hughes', 'John');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (307, 'Madigan', 'Amy');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (305, 'Kelley', 'Jean Louisa');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (306, 'Culkin', 'Macaulay');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (303, 'Hoffmann', 'Gaby');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (304, 'Underwood', 'Jay D.');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (313, 'Yoba', 'Malik');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (312, 'Lewis', 'Rawle D.');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (310, 'Turteltaub', 'Jon');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (311, 'Doug', 'Doug E.');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (309, 'Bannock', 'Derice');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (319, 'Walsh', 'Michael Emmet');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (318, 'Olmos', 'Edward James');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (317, 'Hannah', 'Daryl');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (316, 'Young', 'Sean');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (315, 'Scott', 'Ridley');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (314, 'Hauer', 'Rutger');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (325, 'Walker', 'Kim');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (324, 'Ryder', 'Winona');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (323, 'Slater', 'Christian');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (322, 'Falk', 'Lisanne');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (321, 'Doherty', 'Shannen');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (320, 'Lehmann', 'Michael');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (328, 'Eubanks', 'Bob');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (326, 'Boone', 'Pat');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (329, 'Smith', 'Roger');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (327, 'Moore', 'Michael');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (335, 'Hearn', 'Chick');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (338, 'Davis', 'Geena');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (337, 'Baker', 'Joe Don');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (333, 'Abdul-Jabbar', 'Kareem');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (336, 'Matheson', 'Tim');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (332, 'Ritchie', 'Michael');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (334, 'Wheeler-Nicholson', 'Dana');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (331, 'Wendt', 'George');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (330, 'Chase', 'Chevy');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (342, 'Houston', 'John');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (341, 'Nicholson', 'Jack');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (340, 'Lopez', 'Perry');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (339, 'Dunaway', 'Faye');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (347, 'Garcia', 'Andy');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (346, 'Smith', 'Charles Martin');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (345, 'Connery', 'Sean');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (344, 'Costner', 'Kevin');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (343, 'DePalma', 'Brian');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (351, 'Crystal', 'Billy');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (348, 'Kirby', 'Bruno');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (350, 'Ryan', 'Meg');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (349, 'Reiner', 'Rob');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (359, 'Roache', 'Linus');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (361, 'Sharp', 'Lesley');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (360, 'Bird', 'Antonia');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (358, 'Gibbs', 'Matyelok');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (355, 'Tremarco', 'Christine');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (357, 'Tyson', 'Cathy');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (352, 'Pugh', 'Robert');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (354, 'Ellis', 'James');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (356, 'Wilkinson', 'Tom');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (353, 'Carlyle', 'Robert');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (364, 'Sarandon', 'Susan');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (363, 'Armstrong', 'Gillian');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (362, 'Bale', 'Christian');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (365, 'Richardson', 'Miranda');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (366, 'Malkovich', 'John');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (383, 'Sarandon', 'Chris');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (386, 'Patinkin', 'Mandy');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (385, 'Shawn', 'Wallace');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (384, 'Cook', 'Peter');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (381, 'Falk', 'Peter');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (380, 'Andre the Giant', 'Andre the Giant');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (379, 'Wright', 'Robin');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (378, 'Savage', 'Fred');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (382, 'Guest', 'Christopher');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (377, 'Elwes', 'Cary');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (392, 'Kane', 'Carol');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (390, 'Badger', 'Paul');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (394, 'Brantley', 'Betsy');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (389, 'Dyson', 'Anne');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (393, 'Mason', 'Margery');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (391, 'Storry', 'Malcolm');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (388, 'Gray', 'Willoughby');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (387, 'Smith', 'Mel');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (395, 'Hanks', 'Tom');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (396, 'Allen', 'Tim');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (397, 'Lasseter', 'John');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (402, 'Cartwright', 'Veronica');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (403, 'Stanton', 'Harry Dean');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (400, 'Holm', 'Ian');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (399, 'Weaver', 'Sigourney');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (398, 'Skerritt', 'Tom');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (401, 'Hurt', 'John');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (405, 'Schwarzenegger', 'Arnold');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (404, 'Hamilton', 'Linda');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (406, 'Biehn', 'Michael');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (407, 'Cameron', 'James');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (412, 'Vargas', 'Antonio');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (415, 'Otto', 'Barry');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (413, 'Hunter', 'Bill');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (416, 'Mercurio', 'Paul');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (409, 'Kruger', 'Sonia');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (414, 'Whitford', 'Peter');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (411, 'Carides', 'Gia');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (410, 'Morice', 'Tara');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (408, 'Thompson', 'Pat');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (422, 'Lange', 'Jessica');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (421, 'Pollack', 'Sydney');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (419, 'Coleman', 'Dabney');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (418, 'Murray', 'Bill');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (420, 'Garr', 'Teri');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (417, 'Hoffman', 'Dustin');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (425, 'Roth', 'Tim');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (426, 'Tarantino', 'Quentin');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (429, 'Plummer', 'Amanda');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (430, 'Thurman', 'Uma');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (431, 'Travolta', 'John');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (428, 'Keitel', 'Harvey');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (427, 'Willis', 'Bruce');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (433, 'Hunter', 'Holly');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (432, 'Campion', 'Jane');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (434, 'Paquin', 'Anna');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (437, 'Attenborough', 'Richard');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (438, 'Goldblum', 'Jeff');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (435, 'Spielberg', 'Steven');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (436, 'Dern', 'Laura');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (450, 'Davidtz', 'Embeth');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (449, 'Kingsley', 'Ben');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (448, 'Fiennes', 'Ralph');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (447, 'Neeson', 'Liam');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (453, 'Furst', 'Stephen');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (451, 'Hulce', 'Tom');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (452, 'Sutherland', 'Donald');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (455, 'Gregory', 'Andre');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (454, 'Malle', 'Louis');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (458, 'Warnecke', 'Gordon');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (457, 'Frears', 'Stephen');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (456, 'Day-Lewis', 'Daniel');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (463, ' ', 'Miou-Miou');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (462, 'Huppert', 'Isabelle');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (464, 'Kurys', 'Diane');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (471, 'Burstyn', 'Ellen');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (468, 'Shepherd', 'Cybill');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (469, 'Bottoms', 'Timothy');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (470, 'Leachman', 'Cloris');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (465, 'Castle', 'Nick');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (466, 'Johnson', 'Ben');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (467, 'Bridges', 'Jeff');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (477, 'Sutherland', 'Kiefer');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (476, 'O''Connell', 'Jerry');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (475, 'Wheaton', 'Wil');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (474, 'Pheonix', 'River');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (473, 'Feldman', 'Corey');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (472, 'Cusack', 'John');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (479, 'Van Sant Jr.', 'Gus');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (478, 'Reeves', 'Keanu');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (482, 'Lynch', 'David');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (481, 'Rossellini', 'Isabella');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (480, 'MacLachlan', 'Kyle');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (485, 'Maggio', 'Pupella');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (484, 'Fellini', 'Federico');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (486, 'Noel', 'Magali');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (483, 'Zanin', 'Bruno');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (490, 'Ironside', 'Michael');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (488, 'Stone', 'Sharon');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (491, 'Verhoeven', 'Paul');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (489, 'Cox', 'Ronny');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (487, 'Ticotin', 'Rachel');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (494, 'Weir', 'Peter');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (493, 'Gibson', 'Mel');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (492, 'Hunt', 'Linda');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (495, 'Bening', 'Annette');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (496, 'Huston', 'Anjelica');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (501, 'Bergman', 'Ingmar');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (500, 'Ullmann', 'Liv');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (499, 'Thulin', 'Ingrid');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (498, 'Andersson', 'Harriet');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (497, 'Sylwan', 'Kari');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (505, 'Charbonneau', 'Patricia');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (503, 'Shaver', 'Helen');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (504, 'Deitch', 'Donna');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (502, 'Lindley', 'Audra');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (509, 'Johns', 'Tracy Camilla');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (508, 'Lee', 'Spike');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (507, 'Hicks', 'Tommy Redmond');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (506, 'Terrell', 'John Canada');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (516, 'Edson', 'Richard');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (515, 'Esposito', 'Giancarlo');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (513, 'Lee', 'Joie');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (514, 'Perez', 'Rosie');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (511, 'Davis', 'Ozzie');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (512, 'Aiello', 'Danny');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (510, 'Dee', 'Ruby');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (518, 'McDonald', 'Christopher');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (519, 'Madsen', 'Michael');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (517, 'Pitt', 'Brad');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (523, 'Goldberg', 'Whoopi');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (525, 'Robbins', 'Tim');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (524, 'Gallagher', 'Peter');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (521, 'Ward', 'Fred');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (520, 'Scacchi', 'Greta');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (522, 'Altman', 'Robert');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (527, 'Pakula', 'Alan J.');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (526, 'Fonda', 'Jane');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (529, 'Stewart', 'Charlotte');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (528, 'Nance', 'Jack');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (532, 'Molina', 'Alfred');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (530, 'Redgrave', 'Vanessa');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (531, 'Oldman', 'Gary');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (536, 'Franklin', 'Pamela');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (533, 'Stephens', 'Robert');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (535, 'Smith', 'Maggie');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (534, 'Neame', 'Ronald');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (539, 'Brooks', 'Albert');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (537, 'Boyle', 'Peter');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (538, 'Foster', 'Jodie');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (542, 'Kahn', 'Madeline');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (543, 'Brooks', 'Mel');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (541, 'Wilder', 'Gene');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (540, 'Feldman', 'Marty');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (553, 'Welles', 'Orson');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (551, 'Cotten', 'Joseph');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (549, 'Howard', 'Trevor');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (550, 'Valli', 'Alida');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (552, 'Reed', 'Carol');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (554, 'Bogdanovich', 'Peter');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (557, 'Hitchcock', 'Alfred');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (556, 'Rains', 'Claude');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (555, 'Grant', 'Cary');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (559, 'Comingore', 'Dorothy');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (558, 'Moorehead', 'Agnes');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (562, 'Hepburn', 'Katharine');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (561, 'Stewart', 'James');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (560, 'Cukor', 'George');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (565, 'Robards', 'Jason');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (567, 'Cardinale', 'Claudia');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (566, 'Bronson', 'Charles');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (564, 'Fonda', 'Henry');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (563, 'Leone', 'Sergio');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (570, 'Russell', 'Theresa');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (569, 'Roeg', 'Nicholas');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (576, 'Lugosi', 'Bela');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (573, 'Johnson', 'Tor');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (574, 'Wood Jr.', 'Edward D.');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (572, 'McKinnon', 'Mona');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (575, ' ', 'Vampira');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (571, 'Walcott', 'Gregory');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (584, 'Serlet', 'Bertrand');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (588, 'Federighi', 'Craig');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (587, 'Arthur', 'Bruce');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (585, 'Noyau', 'Eric');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (586, 'Willhite', 'Dan');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (589, 'Gates', 'Patrick');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (590, 'Lydon', 'Rory');
INSERT INTO "Talent" ("Talent_Id", "Last_Name", "First_Name") VALUES (591, 'Herzer', 'Stefanie');
COMMIT;
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (91, 103);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (138, 120);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (88, 101);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (107, 113);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (109, 114);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (99, 111);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (114, 115);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (127, 119);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (117, 118);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (118, 118);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (156, 121);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (151, 121);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (164, 125);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (165, 124);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (207, 126);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (210, 127);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (216, 128);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (218, 129);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (228, 130);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (232, 131);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (237, 132);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (237, 133);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (91, 135);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (251, 136);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (251, 137);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (218, 138);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (277, 140);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (251, 141);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (285, 142);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (300, 143);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (308, 144);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (310, 145);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (315, 146);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (320, 147);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (327, 148);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (332, 149);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (216, 150);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (343, 151);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (349, 152);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (360, 153);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (363, 154);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (397, 158);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (349, 157);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (315, 159);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (407, 160);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (421, 162);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (426, 164);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (432, 165);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (435, 166);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (435, 169);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (300, 170);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (454, 171);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (457, 172);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (464, 174);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (560, 199);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (479, 177);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (349, 176);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (482, 178);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (484, 179);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (491, 180);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (494, 181);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (457, 182);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (501, 183);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (504, 184);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (508, 185);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (508, 186);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (315, 187);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (522, 188);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (527, 189);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (482, 190);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (457, 191);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (534, 192);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (285, 193);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (543, 194);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (552, 196);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (554, 175);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (557, 197);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (553, 198);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (563, 200);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (574, 203);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (333, 129);
INSERT INTO "Director" ("Talent_Id", "Movie_Id") VALUES (590, 205);
COMMIT;
DISCONNECT CURRENT;
connect to movies user movies;
SET TRANSACTION ISOLATION LEVEL SERIALIZABLE, READ WRITE;
ALTER TABLE "Director" ADD PRIMARY KEY ("Movie_Id","Talent_Id");
ALTER TABLE "Movie" ADD PRIMARY KEY ("Movie_Id");
ALTER TABLE "Movie_Role" ADD PRIMARY KEY ("Movie_Id","Talent_Id");
ALTER TABLE "Plot_Summary" ADD PRIMARY KEY ("Movie_Id");
ALTER TABLE "Review" ADD PRIMARY KEY ("Review_Id");
ALTER TABLE "Studio" ADD PRIMARY KEY ("Studio_Id");
ALTER TABLE "Talent" ADD PRIMARY KEY ("Talent_Id");
ALTER TABLE "Talent_Photo" ADD PRIMARY KEY ("Talent_Id");
ALTER TABLE "Voting" ADD PRIMARY KEY ("Movie_Id");
ALTER TABLE "Director" ADD FOREIGN KEY ("Talent_Id") REFERENCES "Talent" ("Talent_Id");
ALTER TABLE "Director" ADD FOREIGN KEY ("Movie_Id") REFERENCES "Movie" ("Movie_Id");
ALTER TABLE "Movie" ADD FOREIGN KEY ("Movie_Id") REFERENCES "Voting" ("Movie_Id");
ALTER TABLE "Movie" ADD FOREIGN KEY ("Studio_Id") REFERENCES "Studio" ("Studio_Id");
ALTER TABLE "Movie" ADD FOREIGN KEY ("Movie_Id") REFERENCES "Plot_Summary" ("Movie_Id");
ALTER TABLE "Movie_Role" ADD FOREIGN KEY ("Talent_Id") REFERENCES "Talent" ("Talent_Id");
ALTER TABLE "Movie_Role" ADD FOREIGN KEY ("Movie_Id") REFERENCES "Movie" ("Movie_Id");
ALTER TABLE "Plot_Summary" ADD FOREIGN KEY ("Movie_Id") REFERENCES "Movie" ("Movie_Id");
ALTER TABLE "Review" ADD FOREIGN KEY ("Movie_Id") REFERENCES "Movie" ("Movie_Id");
ALTER TABLE "Talent" ADD FOREIGN KEY ("Talent_Id") REFERENCES "Talent_Photo" ("Talent_Id");
ALTER TABLE "Talent_Photo" ADD FOREIGN KEY ("Talent_Id") REFERENCES "Talent" ("Talent_Id");
ALTER TABLE "Voting" ADD FOREIGN KEY ("Movie_Id") REFERENCES "Movie" ("Movie_Id");
COMMIT;
DISCONNECT CURRENT;
